searchNodes=[{"type":"module","title":"VintageNet","doc":"VintageNet is network configuration library built specifically for Nerves Project devices. It has the following features: Ethernet and WiFi support included. Extendible to other technologies Default configurations specified in your Application config Runtime updates to configurations are persisted and applied on next boot (can be disabled) Simple subscription to network status change events Connect to multiple networks at a time and prioritize which interfaces are used (Ethernet over WiFi over cellular) Internet connection monitoring and failure detection (currently slow and simplistic) See github.com/nerves-networking/vintage_net for more information.","ref":"VintageNet.html"},{"type":"function","title":"VintageNet.all_interfaces/0","doc":"Return a list of all interfaces on the system","ref":"VintageNet.html#all_interfaces/0"},{"type":"function","title":"VintageNet.configuration_valid?/2","doc":"Check if this is a valid configuration This runs the validation routines for a settings map, but doesn't try to apply them.","ref":"VintageNet.html#configuration_valid?/2"},{"type":"function","title":"VintageNet.configure/3","doc":"Update the configuration of a network interface Configurations are validated and normalized before being applied. This means that type errors and missing required fields will be caught and old or redundant ways of specifying configurations will be fixed. Call get_configuration/1 to see how what changes, if any, were made as part of the normalization process. After validation, the configuration is optionally persisted and applied. See the VintageNet documentation for configuration examples or your VintageNet.Technology provider's docs. Options: :persist - set to false to avoid persisting this configuration. System restarts will revert to the previous configuration. Defaults to true.","ref":"VintageNet.html#configure/3"},{"type":"function","title":"VintageNet.configured_interfaces/0","doc":"Return a list of configured interface","ref":"VintageNet.html#configured_interfaces/0"},{"type":"function","title":"VintageNet.deconfigure/2","doc":"Deconfigure and persists (by default) settings for a specified interface. Supports same options as configure/3","ref":"VintageNet.html#deconfigure/2"},{"type":"function","title":"VintageNet.get/2","doc":"Get the current value of a network property See get_by_prefix/1 for exact prefix matches (i.e., get all properties for one interface) and match/1 to run wildcard matches (i.e., get a specific property for all interfaces).","ref":"VintageNet.html#get/2"},{"type":"function","title":"VintageNet.get_by_prefix/1","doc":"Get a list of all properties matching the specified prefix To get a list of all known properties and their values, call VintageNet.get_by_prefix([])","ref":"VintageNet.html#get_by_prefix/1"},{"type":"function","title":"VintageNet.get_configuration/1","doc":"Return the settings for the specified interface","ref":"VintageNet.html#get_configuration/1"},{"type":"function","title":"VintageNet.info/1","doc":"Print the current network status Options include: :redact - Set to false to print out passwords","ref":"VintageNet.html#info/1"},{"type":"function","title":"VintageNet.ioctl/3","doc":"Run a command on a network interface Commands are mostly network interface-specific. Also see the VintageNet PropertyTable fo getting status or registering for status changes.","ref":"VintageNet.html#ioctl/3"},{"type":"function","title":"VintageNet.match/1","doc":"Get a list of all properties matching a pattern Patterns are list of strings that optionally specify :_ at a position in the list to match any value.","ref":"VintageNet.html#match/1"},{"type":"function","title":"VintageNet.max_interface_count/0","doc":"Return the maximum number of interfaces controlled by VintageNet Internal constraints mean that VintageNet can't manage an arbitrary number of interfaces and knowing the max can reduce some processing. The limit is set by the application config. Unless you need over 100 network interfaces, VintageNet's use of the Linux networking API is not likely to be an issue, though.","ref":"VintageNet.html#max_interface_count/0"},{"type":"function","title":"VintageNet.reset_to_defaults/1","doc":"Configure an interface to use the defaults This configures an interface to the defaults found in the application environment ( config.exs ). If the application environment doesn't have a default configuration, the interface is deconfigured. On reboot, the interface will continue to use the defaults and if a new version of firmware updates the defaults, it will use those.","ref":"VintageNet.html#reset_to_defaults/1"},{"type":"function","title":"VintageNet.scan/1","doc":"Initiate an access point scan on a wireless interface The scan results are posted asynchronously to the [&quot;interface&quot;, ifname, &quot;wifi&quot;, &quot;access_points&quot;] property as they come in. After waiting a second or two they can be fetched via VintageNet.get([&quot;interface&quot;, ifname, &quot;wifi&quot;, &quot;access_points&quot;]) . It appears that there's some variation in how scanning is implemented on WiFi adapters. One strategy that seems to work is to call scan/1 every 10 seconds or so while prompting a user to pick a WiFi network. This is a utility function for calling the :scan ioctl.","ref":"VintageNet.html#scan/1"},{"type":"function","title":"VintageNet.subscribe/1","doc":"Subscribe to property change messages Messages have the form: { VintageNet , property_name , old_value , new_value , metadata } Subscriptions are prefix matches. For example, to get notified whenever a property changes on &quot;wlan0&quot;, run this: VintageNet . subscribe ( [ &quot;interface&quot; , &quot;wlan0&quot; ] ) It's also possible to match with wildcards using :_ . For example, to get notified whenever an IP address in the system changes, do this: VintageNet . subscribe ( [ &quot;interface&quot; , :_ , &quot;addresses&quot; ] )","ref":"VintageNet.html#subscribe/1"},{"type":"function","title":"VintageNet.unsubscribe/1","doc":"Stop subscribing to property change messages","ref":"VintageNet.html#unsubscribe/1"},{"type":"function","title":"VintageNet.verify_system/1","doc":"Check that the system has the required programs installed NOTE: This isn't completely implemented yet!","ref":"VintageNet.html#verify_system/1"},{"type":"type","title":"VintageNet.any_ip_address/0","doc":"IP addresses in VintageNet can be specified as strings or tuples While VintageNet uses IP addresses in tuple form internally, it can be cumbersome to always convert to tuple form in practice. The general rule is that VintageNet is flexible in how it accepts IP addresses, but if you get an address from a VintageNet API, it will be in tuple form.","ref":"VintageNet.html#t:any_ip_address/0"},{"type":"type","title":"VintageNet.configure_options/0","doc":"Valid options for VintageNet.configure/3 :persist - Whether or not to save the configuration (defaults to true )","ref":"VintageNet.html#t:configure_options/0"},{"type":"type","title":"VintageNet.connection_status/0","doc":"Interface connection status :disconnected - The interface doesn't exist or it's not connected :lan - The interface is connected to the LAN, but may not be able reach the Internet :internet - Packets going through the interface should be able to reach the Internet","ref":"VintageNet.html#t:connection_status/0"},{"type":"type","title":"VintageNet.ifname/0","doc":"A name for the network interface Names depend on the device drivers and any software that may rename them. Typical names on Nerves are: &quot;eth0&quot;, &quot;eth1&quot;, etc. for wired Ethernet interfaces &quot;wlan0&quot;, etc. for WiFi interfaces &quot;ppp0&quot; for cellular modems &quot;usb0&quot; for gadget USB virtual Ethernet interfaces","ref":"VintageNet.html#t:ifname/0"},{"type":"type","title":"VintageNet.info_options/0","doc":"Valid options for VintageNet.info/1 :redact - Whether to hide passwords and similar information from the output (defaults to true )","ref":"VintageNet.html#t:info_options/0"},{"type":"type","title":"VintageNet.interface_type/0","doc":"Interface type This is a coarse characterization of a network interface that can be useful for prioritizing interfaces. :ethernet - Wired-based networking. Generally expected to be fast. :wifi - Wireless networking. Expected to be not as fast as Ethernet, :mobile - Cellular-based networking. Expected to be metered and slower than :wifi and :ethernet :local - Interfaces that never route to other hosts :unknown - Catch-all when the network interface can't be categorized These are general categories that are helpful for VintageNet's default routing prioritization. See VintageNet.Route.DefaultMetric for more information on the use.","ref":"VintageNet.html#t:interface_type/0"},{"type":"type","title":"VintageNet.ipv4_prefix_length/0","doc":"The number of bits to use for an IPv4 subnet For example, if you have a subnet mask of 255.255.255.0, then the prefix length would be 24.","ref":"VintageNet.html#t:ipv4_prefix_length/0"},{"type":"type","title":"VintageNet.ipv6_prefix_length/0","doc":"The number of bits to use for an IPv6 subnet","ref":"VintageNet.html#t:ipv6_prefix_length/0"},{"type":"type","title":"VintageNet.pattern/0","doc":"A pattern for matching against VintageNet properties Patterns are used when subscribing for network property changes or getting a set of properties and their values. Since properties are organized hierarchically, the default way of matching patterns is to match on prefixes. It's also possible to use the :_ wildcard to match anything at a position.","ref":"VintageNet.html#t:pattern/0"},{"type":"type","title":"VintageNet.prefix_length/0","doc":"The number of IP address bits for the subnet","ref":"VintageNet.html#t:prefix_length/0"},{"type":"type","title":"VintageNet.property/0","doc":"A VintageNet property VintageNet uses lists of strings to name networking configuration and status items.","ref":"VintageNet.html#t:property/0"},{"type":"type","title":"VintageNet.value/0","doc":"A property's value See the README.md for documenation on available properties.","ref":"VintageNet.html#t:value/0"},{"type":"module","title":"VintageNet.Connectivity.CheckLogic","doc":"Core logic for determining internet connectivity based on check results This module is meant to be used by InternetChecker and others for determining when to run checks and how many failures should change the network interface's state. It implements a state machine that figures out what the connectivity status is based on internet-connectivity check successes and fails. It also returns how long to wait between checks. stateDiagram-v2 direction LR [*]--&gt;internet : init state connected { internet--&gt;lan : max failures lan--&gt;internet : check succeeded } connected--&gt;disconnected : ifdown disconnected--&gt;lan : ifup","ref":"VintageNet.Connectivity.CheckLogic.html"},{"type":"function","title":"VintageNet.Connectivity.CheckLogic.check_failed/1","doc":"Call this when an Internet connectivity check fails Depending on how many failures have happened it a row, the connectivity may be degraded to :lan .","ref":"VintageNet.Connectivity.CheckLogic.html#check_failed/1"},{"type":"function","title":"VintageNet.Connectivity.CheckLogic.check_succeeded/1","doc":"Call this when an Internet connectivity check succeeds","ref":"VintageNet.Connectivity.CheckLogic.html#check_succeeded/1"},{"type":"function","title":"VintageNet.Connectivity.CheckLogic.ifdown/1","doc":"Call this when the interface goes down The interface will be categorized as :disconnected until ifup/1 gets called again.","ref":"VintageNet.Connectivity.CheckLogic.html#ifdown/1"},{"type":"function","title":"VintageNet.Connectivity.CheckLogic.ifup/1","doc":"Call this when the interface comes up It is assumed that the interface has LAN connectivity now and a check will be scheduled to happen shortly.","ref":"VintageNet.Connectivity.CheckLogic.html#ifup/1"},{"type":"function","title":"VintageNet.Connectivity.CheckLogic.init/1","doc":"Initialize check state machine Pass in the assumed connection status. This is a best guess to start things out.","ref":"VintageNet.Connectivity.CheckLogic.html#init/1"},{"type":"type","title":"VintageNet.Connectivity.CheckLogic.state/0","doc":"","ref":"VintageNet.Connectivity.CheckLogic.html#t:state/0"},{"type":"module","title":"VintageNet.Connectivity.Inspector","doc":"This module looks at the network activity of all TCP socket connections known to Erlang/OTP to deduce whether the internet is working. To use it, call check_internet/2 , save the returned cache, and then call it again a minute later (or so). If any socket has transferred data in both directions to an off-LAN host on the interface of interest, then it will return that the internet is available. This has a couple advantages: No data is sent to perform the check which is good for metered connections Most long-lived TCP connections have a keepalive mechanism that generates traffic, so this piggy-backs off that existing connectivity check. Devices can be behind very restrictive firewalls and internet connectivity can still be verified without knowing which IP/port/protocol combinations are allowed. It is not perfect: It only works on long-lived TCP connections. The TCP connection must be sending and receiving data. If the keapalive is longer than the check_internet/2 It doesn't help if nobody is using the network interface. It may have scalability issues if there are a LOT of TCP sockets.","ref":"VintageNet.Connectivity.Inspector.html"},{"type":"function","title":"VintageNet.Connectivity.Inspector.check_internet/2","doc":"Check whether the internet is accessible on the specified interface Pass an empty map for the cache parameter for the first call. Then pass it back the returned cache for each subsequent call. If any TCP socket that's connected to a computer on another subnet and that's using the passed in network interface has send AND received data since the previous call, then :internet is returned. If not, then usually :unknown is returned to signify that internet may be available, but we just don't know. If the interface doesn't have an IP address, then :no_internet is returned, since that's a prerequisite to communicating with anyone on the internet.","ref":"VintageNet.Connectivity.Inspector.html#check_internet/2"},{"type":"function","title":"VintageNet.Connectivity.Inspector.on_interface?/2","doc":"Return true if an IP address is on one of the subnets in a list","ref":"VintageNet.Connectivity.Inspector.html#on_interface?/2"},{"type":"function","title":"VintageNet.Connectivity.Inspector.on_subnet?/2","doc":"Return true if an IP address is in the subnet Examples iex&gt; Inspector . on_subnet? ( { 192 , 168 , 0 , 50 } , { { 192 , 168 , 0 , 1 } , { 255 , 255 , 255 , 0 } } ) true iex&gt; Inspector . on_subnet? ( { 192 , 168 , 5 , 1 } , { { 192 , 168 , 0 , 1 } , { 255 , 255 , 255 , 0 } } ) false","ref":"VintageNet.Connectivity.Inspector.html#on_subnet?/2"},{"type":"function","title":"VintageNet.Connectivity.Inspector.routed_address?/2","doc":"Returns true if the specified address is not on the network interface This function is useful for checking whether an address is on the Internet if you don't trust the DNS server. Captive portals, for example, can give back IP addresses that are local. It's not guaranteed, but it would be pointless to check those IP's if you're looking for the Internet.","ref":"VintageNet.Connectivity.Inspector.html#routed_address?/2"},{"type":"type","title":"VintageNet.Connectivity.Inspector.cache/0","doc":"Cache for use between check_internet/2 calls. Initialize to an empty map.","ref":"VintageNet.Connectivity.Inspector.html#t:cache/0"},{"type":"type","title":"VintageNet.Connectivity.Inspector.result/0","doc":"The return tuple for check_internet/2 :internet - at least one TCP connection sent and received data to a non-LAN IP address :unknown - no conclusion could be made :no_internet - the interface didn't have an IP address, so Internet is definitely not available Save the cache away and pass it to the next call to check_internet/2 .","ref":"VintageNet.Connectivity.Inspector.html#t:result/0"},{"type":"type","title":"VintageNet.Connectivity.Inspector.status/0","doc":"Internet connectivity status :internet - the internet is available :unknown - not sure :no_internet - the internet is definitely not available","ref":"VintageNet.Connectivity.Inspector.html#t:status/0"},{"type":"module","title":"VintageNet.Connectivity.InternetChecker","doc":"This GenServer monitors a network interface for Internet connectivity Internet connectivity is determined by reachability to an IP address. If that address is reachable then other this updates a property to reflect that. Otherwise, the network interface is assumed to merely have LAN connectivity if it's up.","ref":"VintageNet.Connectivity.InternetChecker.html"},{"type":"function","title":"VintageNet.Connectivity.InternetChecker.child_spec/1","doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"VintageNet.Connectivity.InternetChecker.html#child_spec/1"},{"type":"function","title":"VintageNet.Connectivity.InternetChecker.start_link/1","doc":"Start the connectivity checker GenServer","ref":"VintageNet.Connectivity.InternetChecker.html#start_link/1"},{"type":"module","title":"VintageNet.Connectivity.LANChecker","doc":"This GenServer monitors a network interface for LAN connectivity Currently LAN connectivity simply looks to see if it's possible to send a packet on the interface. It might or might not get to the desired destination on the LAN, but it won't obviously fail. This is an alternative to the InternetConnectivityChecker that actively monitors reachability to a host.","ref":"VintageNet.Connectivity.LANChecker.html"},{"type":"function","title":"VintageNet.Connectivity.LANChecker.child_spec/1","doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"VintageNet.Connectivity.LANChecker.html#child_spec/1"},{"type":"function","title":"VintageNet.Connectivity.LANChecker.start_link/1","doc":"Start the connectivity checker GenServer","ref":"VintageNet.Connectivity.LANChecker.html#start_link/1"},{"type":"module","title":"VintageNet.Connectivity.TCPPing","doc":"Test connectivity by making a connection using TCP Connectivity with a remote host can be checked by making a TCP connection to it. The connection either works, the connection is refused, or it times out. The first two cases indicate connectivity. Normally ICMP is used for testing connectivity, but that requires the new socket API and a Linux kernel with net.ipv4.ping_group_range enabled. This way usually works unless a device is behind a strict firewall, but there's usually at least one IP address/port on the Internet that they allow.","ref":"VintageNet.Connectivity.TCPPing.html"},{"type":"function","title":"VintageNet.Connectivity.TCPPing.ping/2","doc":"Check connectivity with another device The &quot;ping&quot; is really a TCP connection attempt from the specified interface to an IP address and port. Failures to connect don't necessarily mean that the Internet is down, but it's likely especially if the server that's specified in the configuration is highly available. Source IP-based routing is required for the TCP connect to go out the right network interface. This is configured by default when using VintageNet.","ref":"VintageNet.Connectivity.TCPPing.html#ping/2"},{"type":"type","title":"VintageNet.Connectivity.TCPPing.ping_error_reason/0","doc":"","ref":"VintageNet.Connectivity.TCPPing.html#t:ping_error_reason/0"},{"type":"module","title":"VintageNet.DHCP.Options","doc":"DHCP Options","ref":"VintageNet.DHCP.Options.html"},{"type":"type","title":"VintageNet.DHCP.Options.t/0","doc":"A map of options and other information reported by udhcpc Here's an example: %{ broadcast : { 192 , 168 , 7 , 255 } , dns : { 192 , 168 , 7 , 1 } , domain : &quot;hunleth.lan&quot; , hostname : &quot;nerves-9780&quot; , ip : { 192 , 168 , 7 , 190 } , lease : 86400 , mask : 24 , router : { 192 , 168 , 7 , 1 } , serverid : { 192 , 168 , 7 , 1 } , siaddr : { 192 , 168 , 7 , 1 } , subnet : { 255 , 255 , 255 , 0 } }","ref":"VintageNet.DHCP.Options.html#t:t/0"},{"type":"module","title":"VintageNet.IP","doc":"This module contains utilities for handling IP addresses. By far the most important part of handling IP addresses is to pay attention to whether your addresses are names, IP addresses as strings or IP addresses at tuples. This module doesn't resolve names. While IP addresses in string form are convenient to type, nearly all Erlang and Elixir code uses IP addresses in tuple form.","ref":"VintageNet.IP.html"},{"type":"function","title":"VintageNet.IP.cidr_to_string/2","doc":"Convert an IP address w/ prefix to a CIDR-formatted string Examples: iex&gt; VintageNet.IP . cidr_to_string ( { 192 , 168 , 0 , 1 } , 24 ) &quot;192.168.0.1/24&quot;","ref":"VintageNet.IP.html#cidr_to_string/2"},{"type":"function","title":"VintageNet.IP.ip_to_string/1","doc":"Convert an IP address to a string Examples: iex&gt; VintageNet.IP . ip_to_string ( { 192 , 168 , 0 , 1 } ) &quot;192.168.0.1&quot; iex&gt; VintageNet.IP . ip_to_string ( &quot;192.168.9.1&quot; ) &quot;192.168.9.1&quot; iex&gt; VintageNet.IP . ip_to_string ( { 65152 , 0 , 0 , 0 , 0 , 0 , 0 , 1 } ) &quot;fe80::1&quot;","ref":"VintageNet.IP.html#ip_to_string/1"},{"type":"function","title":"VintageNet.IP.ip_to_tuple/1","doc":"Convert an IP address to tuple form Examples: iex&gt; VintageNet.IP . ip_to_tuple ( &quot;192.168.0.1&quot; ) { :ok , { 192 , 168 , 0 , 1 } } iex&gt; VintageNet.IP . ip_to_tuple ( { 192 , 168 , 1 , 1 } ) { :ok , { 192 , 168 , 1 , 1 } } iex&gt; VintageNet.IP . ip_to_tuple ( &quot;fe80::1&quot; ) { :ok , { 65152 , 0 , 0 , 0 , 0 , 0 , 0 , 1 } } iex&gt; VintageNet.IP . ip_to_tuple ( { 65152 , 0 , 0 , 0 , 0 , 0 , 0 , 1 } ) { :ok , { 65152 , 0 , 0 , 0 , 0 , 0 , 0 , 1 } } iex&gt; VintageNet.IP . ip_to_tuple ( &quot;bologna&quot; ) { :error , &quot;Invalid IP address: bologna&quot; }","ref":"VintageNet.IP.html#ip_to_tuple/1"},{"type":"function","title":"VintageNet.IP.ip_to_tuple!/1","doc":"Raising version of ip_to_tuple/1","ref":"VintageNet.IP.html#ip_to_tuple!/1"},{"type":"function","title":"VintageNet.IP.ipv4_broadcast_address/2","doc":"Return the IPv4 broadcast address for the specified subnet and prefix Examples: iex&gt; VintageNet.IP . ipv4_broadcast_address ( { 192 , 168 , 1 , 50 } , 24 ) { 192 , 168 , 1 , 255 } iex&gt; VintageNet.IP . ipv4_broadcast_address ( { 74 , 125 , 227 , 0 } , 29 ) { 74 , 125 , 227 , 7 }","ref":"VintageNet.IP.html#ipv4_broadcast_address/2"},{"type":"function","title":"VintageNet.IP.prefix_length_to_subnet_mask/2","doc":"Convert an IPv4 or IPv6 prefix length to a subnet mask. Examples: iex&gt; VintageNet.IP . prefix_length_to_subnet_mask ( :inet , 24 ) { 255 , 255 , 255 , 0 } iex&gt; VintageNet.IP . prefix_length_to_subnet_mask ( :inet , 28 ) { 255 , 255 , 255 , 240 } iex&gt; VintageNet.IP . prefix_length_to_subnet_mask ( :inet6 , 64 ) { 65535 , 65535 , 65535 , 65535 , 0 , 0 , 0 , 0 }","ref":"VintageNet.IP.html#prefix_length_to_subnet_mask/2"},{"type":"function","title":"VintageNet.IP.subnet_mask_to_prefix_length/1","doc":"Convert an IPv4 subnet mask to a prefix length. Examples: iex&gt; VintageNet.IP . subnet_mask_to_prefix_length ( { 255 , 255 , 255 , 0 } ) { :ok , 24 } iex&gt; VintageNet.IP . subnet_mask_to_prefix_length ( { 192 , 168 , 1 , 1 } ) { :error , &quot;{192, 168, 1, 1} is not a valid IPv4 subnet mask&quot; }","ref":"VintageNet.IP.html#subnet_mask_to_prefix_length/1"},{"type":"function","title":"VintageNet.IP.to_subnet/2","doc":"Utility function to trim an IP address to its subnet Examples: iex&gt; VintageNet.IP . to_subnet ( { 192 , 168 , 1 , 50 } , 24 ) { 192 , 168 , 1 , 0 } iex&gt; VintageNet.IP . to_subnet ( { 192 , 168 , 255 , 50 } , 22 ) { 192 , 168 , 252 , 0 } iex&gt; VintageNet.IP . to_subnet ( { 64768 , 43690 , 0 , 0 , 4144 , 58623 , 65276 , 33158 } , 64 ) { 64768 , 43690 , 0 , 0 , 0 , 0 , 0 , 0 }","ref":"VintageNet.IP.html#to_subnet/2"},{"type":"module","title":"VintageNet.IP.DhcpdConfig","doc":"This is a helper module for VintageNet.Technology implementations that use a DHCP server. DHCP server parameters are: :start - Start of the lease block :end - End of the lease block :max_leases - The maximum number of leases :decline_time - The amount of time that an IP will be reserved (leased to nobody) :conflict_time -The amount of time that an IP will be reserved :offer_time - How long an offered address is reserved (seconds) :min_lease - If client asks for lease below this value, it will be rounded up to this value (seconds) :auto_time - The time period at which udhcpd will write out leases file. :static_leases - list of {mac_address, ip_address} :options - a map DHCP response options to set. Such as: :dns - IP_LIST :domain - STRING - [0x0f] client's domain suffix :hostname - STRING :mtu - NUM :router - IP_LIST :search - STRING_LIST - [0x77] search domains :serverid - IP (defaults to the interface's IP address) :subnet or :netmask - IP as a subnet mask ( :netmask is an alias for :subnet ) :options Options may also be passed in as integers. These are passed directly to the DHCP server and their values are strings that are not interpreted by VintageNet. Use this to support custom DHCP header options. For more details on DHCP response options see RFC 2132 Example VintageNet . configure ( &quot;wlan0&quot; , %{ type : VintageNetWiFi , vintage_net_wifi : %{ networks : [ %{ mode : :ap , ssid : &quot;test ssid&quot; , key_mgmt : :none } ] } , dhcpd : %{ start : &quot;192.168.24.2&quot; , end : &quot;192.168.24.10&quot; , options : %{ dns : [ &quot;1.1.1.1&quot; , &quot;1.0.0.1&quot; ] , netmask : &quot;255.255.255.0&quot; , router : [ &quot;192.168.24.1&quot; ] } } } )","ref":"VintageNet.IP.DhcpdConfig.html"},{"type":"function","title":"VintageNet.IP.DhcpdConfig.add_config/3","doc":"Add udhcpd configuration commands for running a DHCP server","ref":"VintageNet.IP.DhcpdConfig.html#add_config/3"},{"type":"function","title":"VintageNet.IP.DhcpdConfig.normalize/1","doc":"Normalize the DHCPD parameters in a configuration.","ref":"VintageNet.IP.DhcpdConfig.html#normalize/1"},{"type":"module","title":"VintageNet.IP.DnsdConfig","doc":"This is a helper module for VintageNet.Technology implementations that use the Busybox DNS server. DNS functionality is only supported for IPv4 configurations using static IP addresses. DNS server parameters are: :port - The port to use (defaults to 53) :ttl - DNS record TTL in seconds (defaults to 120) :records - DNS A records (required) The :records option is a list of name/IP address tuples. For example: [ { &quot;example.com&quot; , { 1 , 2 , 3 , 4 } } ] Only IPv4 addresses are supported. Addresses may be specified as strings or tuples, but will be normalized to tuple form before being applied.","ref":"VintageNet.IP.DnsdConfig.html"},{"type":"function","title":"VintageNet.IP.DnsdConfig.add_config/3","doc":"Add dnsd configuration commands for running a DNSD server","ref":"VintageNet.IP.DnsdConfig.html#add_config/3"},{"type":"function","title":"VintageNet.IP.DnsdConfig.normalize/1","doc":"Normalize the DNSD parameters in a configuration.","ref":"VintageNet.IP.DnsdConfig.html#normalize/1"},{"type":"module","title":"VintageNet.IP.IPv4Config","doc":"This is a helper module for VintageNet.Technology implementations that use IPv4. IPv4 configuration is specified under the :ipv4 key in the configuration map. Fields include: :method - :dhcp , :static , or :disabled The :dhcp method currently has no additional fields. The :static method uses the following fields: :address - the IP address :prefix_length - the number of bits in the IP address to use for the subnet (e.g., 24) :netmask - either this or prefix_length is used to determine the subnet. If you have a choice, use prefix_length :gateway - the default gateway for this interface (optional) :name_servers - a list of DNS servers (optional) :domain - DNS search domain (optional) Configuration normalization converts :netmask to :prefix_length .","ref":"VintageNet.IP.IPv4Config.html"},{"type":"function","title":"VintageNet.IP.IPv4Config.add_config/3","doc":"Add IPv4 configuration commands for supporting static and dynamic IP addressing","ref":"VintageNet.IP.IPv4Config.html#add_config/3"},{"type":"function","title":"VintageNet.IP.IPv4Config.normalize/1","doc":"Normalize the IPv4 parameters in a configuration.","ref":"VintageNet.IP.IPv4Config.html#normalize/1"},{"type":"module","title":"VintageNet.Interface","doc":"Manage a network interface at a very high level This module handles configuring network interfaces, making sure that configuration failures get retried, and then cleaning up after it's not needed. The actual code that supplies the configuration implements the VintageNet.Technology behaviour.","ref":"VintageNet.Interface.html"},{"type":"function","title":"VintageNet.Interface.child_spec/1","doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"VintageNet.Interface.html#child_spec/1"},{"type":"function","title":"VintageNet.Interface.configure/3","doc":"Set a configuration on an interface Configurations with invalid parameters raise exceptions. It's still possible that network configurations won't work even if they don't raise, but it should be due to something in the environment. For example, a network cable isn't plugged in or a WiFi access point is out of range.","ref":"VintageNet.Interface.html#configure/3"},{"type":"function","title":"VintageNet.Interface.deconfigure/2","doc":"Deconfigure the interface This doesn't exit this GenServer, but the interface won't be usable in any real way until it's configured again. This function is not normally called.","ref":"VintageNet.Interface.html#deconfigure/2"},{"type":"function","title":"VintageNet.Interface.ioctl/3","doc":"Run an I/O command on the specified interface","ref":"VintageNet.Interface.html#ioctl/3"},{"type":"function","title":"VintageNet.Interface.start_link/1","doc":"Start up an interface Parameters: ifname - which interface","ref":"VintageNet.Interface.html#start_link/1"},{"type":"function","title":"VintageNet.Interface.stop/1","doc":"Stop the interface Note that this doesn't deconfigure it.","ref":"VintageNet.Interface.html#stop/1"},{"type":"function","title":"VintageNet.Interface.to_raw_config/2","doc":"Convert a configuration to a raw one This can be used to validate a configuration without applying it.","ref":"VintageNet.Interface.html#to_raw_config/2"},{"type":"function","title":"VintageNet.Interface.wait_until_configured/1","doc":"Wait for the interface to be configured","ref":"VintageNet.Interface.html#wait_until_configured/1"},{"type":"module","title":"VintageNet.Interface.CommandRunner","doc":"The CommandRunner module runs commands specified in RawConfigs See the RawConfig documentation for where lists of commands are specified. The following commands are supported: {:run, command, args} - Run a system command {:run_ignore_exit, command, args} - Same as :run , but without the exit status check {:fun, module, function_name, args} - Run a function by MFArgs {:fun, fun} - Run a function. Using the MFArgs form is preferred since it's easier to verify in unit tests . CommandRunner also implements RawConfig's file creation and cleanup logic.","ref":"VintageNet.Interface.CommandRunner.html"},{"type":"function","title":"VintageNet.Interface.CommandRunner.create_files/1","doc":"Create a list of files","ref":"VintageNet.Interface.CommandRunner.html#create_files/1"},{"type":"function","title":"VintageNet.Interface.CommandRunner.remove_files/1","doc":"Remove a list of files","ref":"VintageNet.Interface.CommandRunner.html#remove_files/1"},{"type":"function","title":"VintageNet.Interface.CommandRunner.run/1","doc":"Run one or more commands See the module docs for documentation on commands.","ref":"VintageNet.Interface.CommandRunner.html#run/1"},{"type":"module","title":"VintageNet.Interface.EAPStatus","doc":"Status of an EAP connection. Keys status Status of the connection. :started - the AP was assosiated and EAP is started. :success - the EAP connection was successful :failure - the EAP connection failed. method - EAP method used to authenticate. See the typespec for available values. timestamp - DateTime of the most recent EAP event. remote_certificate_verified? - if the cert was verified by the EAP server.","ref":"VintageNet.Interface.EAPStatus.html"},{"type":"type","title":"VintageNet.Interface.EAPStatus.method/0","doc":"Can be one of: as defined in eap_defs.h in the hostapd source. NONE IDENTITY NOTIFICATION NAK MD5 OTP GTC TLS LEAP SIM TTLS AKA PEAP MSCHAPV2 TLV TNC FAST PAX PSK SAKE IKEV2 AKA_PRIME GPSK PWD EKE TEAP EXPANDED","ref":"VintageNet.Interface.EAPStatus.html#t:method/0"},{"type":"type","title":"VintageNet.Interface.EAPStatus.t/0","doc":"","ref":"VintageNet.Interface.EAPStatus.html#t:t/0"},{"type":"module","title":"VintageNet.Interface.IfupDaemon","doc":"Wrap MuonTrap.Daemon to start and stop a program based on whether the network is up Unlike MuonTrap.Daemon, the arguments are called out in the child_spec so it looks like this: { VintageNet.Interface.IfupDaemon , ifname : ifname , command : program , args : arguments , opts : options ] }","ref":"VintageNet.Interface.IfupDaemon.html"},{"type":"function","title":"VintageNet.Interface.IfupDaemon.child_spec/1","doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"VintageNet.Interface.IfupDaemon.html#child_spec/1"},{"type":"function","title":"VintageNet.Interface.IfupDaemon.running?/1","doc":"Return whether the daemon is running","ref":"VintageNet.Interface.IfupDaemon.html#running?/1"},{"type":"function","title":"VintageNet.Interface.IfupDaemon.start_link/1","doc":"Start the IfupDaemon","ref":"VintageNet.Interface.IfupDaemon.html#start_link/1"},{"type":"module","title":"VintageNet.Interface.NameUtilities","doc":"Module for classifying network interfaces","ref":"VintageNet.Interface.NameUtilities.html"},{"type":"function","title":"VintageNet.Interface.NameUtilities.get_instance/1","doc":"Extract a number out of an interface name The result is the interface index for most interfaces seen on Nerves (eth0, eth1, ...), and something quite imperfect when using predictable interface naming (enp6s0, enp6s1). This is currently used to order priorities when there are two interfaces available of the same type that cannot be differentiated by other means. It has the one property of being easy to explain.","ref":"VintageNet.Interface.NameUtilities.html#get_instance/1"},{"type":"function","title":"VintageNet.Interface.NameUtilities.to_type/1","doc":"Classify a network type based on its name Examples iex&gt; NameUtilities . to_type ( &quot;eth0&quot; ) :ethernet iex&gt; NameUtilities . to_type ( &quot;wlp5s0&quot; ) :wifi iex&gt; NameUtilities . to_type ( &quot;wwan0&quot; ) :mobile","ref":"VintageNet.Interface.NameUtilities.html#to_type/1"},{"type":"module","title":"VintageNet.Interface.RawConfig","doc":"Raw configuration for an interface This struct contains the low-level instructions for how to configure and deconfigure an interface. Fields: :ifname - the name of the interface (e.g., &quot;eth0&quot; ) :type - the type of network interface (aka the module that created the config) :source_config - the configuration that generated this one :required_ifnames - a list of ifnames that need to exist before starting this configuration. (e.g. [&quot;eth0&quot;] ) :retry_millis - if bringing the interface up fails, wait this amount of time before retrying :files - a list of file path, content tuples :restart_strategy - the restart strategy for the list of child_specs . I.e., :one_for_one | :one_for_all | :rest_for_one :child_specs - a set of child_specs for GenServers to start up and supervise :up_cmd_millis - the maximum amount of time to allow the up command list to take :up_cmds - a list of commands to run to configure the interface :down_cmd_millis - the maximum amount of time to allow the down command list to take :down_cmds - a list of commands to run to bring the interface down :cleanup_files - additional files to delete (the files listed in files are deleted too)","ref":"VintageNet.Interface.RawConfig.html"},{"type":"type","title":"VintageNet.Interface.RawConfig.command/0","doc":"A command to run for RawConfig.up_cmds or RawConfig.down_cmds","ref":"VintageNet.Interface.RawConfig.html#t:command/0"},{"type":"type","title":"VintageNet.Interface.RawConfig.file_contents/0","doc":"","ref":"VintageNet.Interface.RawConfig.html#t:file_contents/0"},{"type":"type","title":"VintageNet.Interface.RawConfig.t/0","doc":"","ref":"VintageNet.Interface.RawConfig.html#t:t/0"},{"type":"behaviour","title":"VintageNet.InterfaceRenamer","doc":"Wrapper around the ip command for renaming interfaces","ref":"VintageNet.InterfaceRenamer.html"},{"type":"function","title":"VintageNet.InterfaceRenamer.rename/2","doc":"Renames an interface","ref":"VintageNet.InterfaceRenamer.html#rename/2"},{"type":"callback","title":"VintageNet.InterfaceRenamer.rename_interface/2","doc":"","ref":"VintageNet.InterfaceRenamer.html#c:rename_interface/2"},{"type":"module","title":"VintageNet.InterfacesMonitor","doc":"Monitor available interfaces Currently this works by polling the system for what interfaces are visible. They may or may not be configured.","ref":"VintageNet.InterfacesMonitor.html"},{"type":"function","title":"VintageNet.InterfacesMonitor.child_spec/1","doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"VintageNet.InterfacesMonitor.html#child_spec/1"},{"type":"function","title":"VintageNet.InterfacesMonitor.force_clear_ipv4_addresses/1","doc":"Force clear all addresses This is useful to notify everyone that an address should not be used immediately. This can be used to fix a race condition where the blip for an address going away to coming back isn't reported.","ref":"VintageNet.InterfacesMonitor.html#force_clear_ipv4_addresses/1"},{"type":"function","title":"VintageNet.InterfacesMonitor.start_link/1","doc":"","ref":"VintageNet.InterfacesMonitor.html#start_link/1"},{"type":"module","title":"VintageNet.NameResolver","doc":"This module manages the contents of &quot;/etc/resolv.conf&quot;. This file is used by the C standard library and by Erlang for resolving domain names. Since both C programs and Erlang can do resolution, debugging problems in this area can be confusing due to varying behavior based on who's resolving at the time. See the /etc/erl_inetrc file on the target to review Erlang's configuration. This module assumes exclusive ownership on &quot;/etc/resolv.conf&quot;, so if any other code in the system tries to modify the file, their changes will be lost on the next update. It is expected that each network interface provides a configuration. This module will track configurations to network interfaces so that it can reflect which resolvers are around. Resolver order isn't handled.","ref":"VintageNet.NameResolver.html"},{"type":"function","title":"VintageNet.NameResolver.child_spec/1","doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"VintageNet.NameResolver.html#child_spec/1"},{"type":"function","title":"VintageNet.NameResolver.clear/1","doc":"Clear all entries in &quot;/etc/resolv.conf&quot; that are associated with the specified interface.","ref":"VintageNet.NameResolver.html#clear/1"},{"type":"function","title":"VintageNet.NameResolver.clear_all/0","doc":"Completely clear out &quot;/etc/resolv.conf&quot;.","ref":"VintageNet.NameResolver.html#clear_all/0"},{"type":"function","title":"VintageNet.NameResolver.setup/3","doc":"Set the search domain and name server list for the specified interface. This replaces any entries in the /etc/resolv.conf for this interface.","ref":"VintageNet.NameResolver.html#setup/3"},{"type":"function","title":"VintageNet.NameResolver.start_link/1","doc":"Start the resolv.conf manager. Accepted args: resolvconf - path to the resolvconf file additional_name_servers - list of additional servers","ref":"VintageNet.NameResolver.html#start_link/1"},{"type":"function","title":"VintageNet.NameResolver.stop/0","doc":"Stop the resolv.conf manager.","ref":"VintageNet.NameResolver.html#stop/0"},{"type":"type","title":"VintageNet.NameResolver.state/0","doc":"","ref":"VintageNet.NameResolver.html#t:state/0"},{"type":"behaviour","title":"VintageNet.Persistence","doc":"Customize the way VintageNet saves and loads configurations","ref":"VintageNet.Persistence.html"},{"type":"function","title":"VintageNet.Persistence.call/2","doc":"","ref":"VintageNet.Persistence.html#call/2"},{"type":"callback","title":"VintageNet.Persistence.clear/1","doc":"Clear out a previously saved configuration","ref":"VintageNet.Persistence.html#c:clear/1"},{"type":"callback","title":"VintageNet.Persistence.enumerate/0","doc":"Enumerate the interfaces that have saved configurations This returns a list of interface names.","ref":"VintageNet.Persistence.html#c:enumerate/0"},{"type":"callback","title":"VintageNet.Persistence.load/1","doc":"Load the configuration of an interface","ref":"VintageNet.Persistence.html#c:load/1"},{"type":"callback","title":"VintageNet.Persistence.save/2","doc":"Save the configuration for the specified interface","ref":"VintageNet.Persistence.html#c:save/2"},{"type":"module","title":"VintageNet.Persistence.FlatFile","doc":"Save and load configurations from flat files","ref":"VintageNet.Persistence.FlatFile.html"},{"type":"module","title":"VintageNet.Persistence.Null","doc":"Don't save or load configuration at all.","ref":"VintageNet.Persistence.Null.html"},{"type":"behaviour","title":"VintageNet.PowerManager","doc":"This is a behaviour for implementing platform-specific power management. From VintageNet's point of view, network devices have the following lifecycle: off -- -&gt; on -- -&gt; powering - off -- -&gt; off Power management does not necessarily mean controlling the power. The end effect should be similar, since VintageNet will try to toggle the power off and on if the network interface doesn't seem to be working. For example, unloading the kernel module for the network device on &quot;power off&quot; and loading it on &quot;power on&quot; may have the desired effect of getting a network interface unstuck. When a device is &quot;on&quot;, VintageNet expects to be regularly told that the device is working ok. Working ok is device dependent, but could be something like the device has transmitted and received data. If VintageNet is not told that the device is working for a long enough time, it will reset the device by powering it off and then back on again. VintageNet calls functions here based on how it wants to transition a device. VintageNet maintains the device's power status internally, so implementations can blindly do what VintageNet tells them too in most cases. Powering on and off can be asynchronous to these function calls. VintageNet uses the presence of the networking interface (like &quot;wlan0&quot;) to determine when the device is really available for networking. The following timeouts are important to consider (in milliseconds): time_to_power_off power_on_hold_time min_power_off_time watchdog_timeout The time_to_power_off specifies the time in the powering-off state. This is the maximum time to allow for a graceful shutdown. VintageNet won't bother the device until that time has expired. That means that if there's a request to use the device, it will wait the powering-off time before calling finish_power_off and then it will power the device back on. Device app notes may have recommendations for this time. The power_on_hold_time specifies how much time a device should be in the powered-on state before it is ok to power off again. This allows devices some time to initialize and recover on their own. The min_power_off_time specifies how long the device should remain powered off before it is powered back on. Finally, watchdog_timeout specifies how long to wait between notifications that the device is ok. Code reports that a device is ok by calling VintageNet.PowerManager.PMControl.pet_watchdog/1 . While normal Erlang supervision expects that it can restart processes immediately and without regard to how long they have been running, bad things can happen to hardware if too aggressively restarted. Devices also initialize asynchronously so it's hard to know when they're fully available and some flakiness may be naturally due to VintageNet not knowing how to wait for a component to finish initialization. Please review your network device's power management guidelines before too aggressively reducing hold times. Cellular devices, in particular, want to signal their disconnection from the network to the tower and flush any unsaved configuration changes to Flash before power removal. Here's an example for a cellular device with a reset line connected to it: power_on - De-assert the reset line. Return a power_on_hold_time of 10 minutes start_powering_off - Open the UART and send the power down command to the modem. Return a time_to_power_off of 1 minute. power_off - Assert the reset line and return that power shouldn't be turned back on for another 10 seconds. PowerManager implementation lifetimes are the same as VintageNet's. In other words, they start and end with VintageNet. This is unlike a network interface which runs only as its existence and configuration allow. As such, VintageNet needs to know about all PowerManager implementations in its application environment. For example, add something like this to your config.exs : config :vintage_net , power_managers : [ { MyCellularPM , [ ifname : &quot;ppp0&quot; , watchdog_timeout : 60_000 , reset_gpio : 123 ] } ] Each tuple is the implementation's module name and init arguments. VintageNet requires :ifname to be set. If you're managing the power for an interface with a dynamic name, enable predictable interface naming with VintageNet and use that name. The watchdog_timeout parameter is optional and defaults to one minute.","ref":"VintageNet.PowerManager.html"},{"type":"callback","title":"VintageNet.PowerManager.handle_info/2","doc":"Handle other messages All unknown messages sent to the power management GenServer come here. This callback is similar to GenServer.handle_info/2 . To receive your own messages here, send them to self() in code run in any of the other callbacks. Another option is to call VintageNet.PowerManager.PMControl.send_message/2","ref":"VintageNet.PowerManager.html#c:handle_info/2"},{"type":"callback","title":"VintageNet.PowerManager.init/1","doc":"Initialize state for managing the power to the specified interface This is called on start and if the power management GenServer restarts. It should not assume that hardware is powered down. IMPORTANT: VintageNet assumes that init/1 runs quickly and succeeds. Errors and exceptions from calling init/1 are handled by disabling the PowerManager. The reason is that VintageNet has no knowledge on how to recover and disabling a power manager was deemed less bad that having supervision tree failures propagate upwards to terminate VintageNet. Messages are logged if this does happen.","ref":"VintageNet.PowerManager.html#c:init/1"},{"type":"callback","title":"VintageNet.PowerManager.power_off/1","doc":"Power off the hardware This function should finish powering off the network interface hardware. Since this is called after the graceful power down should have completed, it should forcefully turn off the power to the hardware. The implementation also returns a time that power must remain off, in milliseconds. power_on/1 won't be called until that time expires.","ref":"VintageNet.PowerManager.html#c:power_off/1"},{"type":"callback","title":"VintageNet.PowerManager.power_on/1","doc":"Power on the hardware for a network interface The function should turn on power rails, deassert reset lines, load kernel modules or do whatever else is necessary to make the interface show up in Linux. Failure handling is not supported by VintageNet yet, so if power up can fail and the right handling for that is to try again later, then this function should do that. It is ok for this function to return immediately. When the network interface appears, VintageNet will start trying to use it. The return tuple should include the number of milliseconds VintageNet should wait before trying to power down the module again. This value should be sufficiently large to avoid getting into loops where VintageNet gives up on a network interface before it has initialized. 10 minutes (600,000 milliseconds), for example, is a reasonable setting.","ref":"VintageNet.PowerManager.html#c:power_on/1"},{"type":"callback","title":"VintageNet.PowerManager.start_powering_off/1","doc":"Start powering off the hardware for a network interface This function should start a graceful shutdown of the network interface hardware. It may return immediately. The return value specifies how long in milliseconds VintageNet should wait before calling power_off/2 . The idea is that a graceful power off should be allowed some time to complete, but not forever.","ref":"VintageNet.PowerManager.html#c:start_powering_off/1"},{"type":"module","title":"VintageNet.PowerManager.PMControl","doc":"Power management control GenServer This GenServer runs a PowerManager implementation for a network device. It provides the API for powering on and off a device and for signally that it's working well. Internally, it runs a state machine that translates power on and off requests into actions sent to the PowerManager implementation. The state machine handles the timing of actions so that hardware gets a chance to initialize and isn't reset to quickly. PowerManager implementations specify times. Since networking devices can sometimes hang or fail in unexpected ways, this module can power them off and on to try to get them back in a good state. This is implemented in terms of a watchdog. Code that can detect the network device being in a good state should call pet_watchdog/1 . For example, code that checks internet connectivity could call pet_watchdog/1 since that's a pretty good sign that the device works. Other checks are possible. If pet_watchdog/1 isn't called, this module will restart the network device.","ref":"VintageNet.PowerManager.PMControl.html"},{"type":"function","title":"VintageNet.PowerManager.PMControl.child_spec/1","doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"VintageNet.PowerManager.PMControl.html#child_spec/1"},{"type":"function","title":"VintageNet.PowerManager.PMControl.force_reset/1","doc":"Force reset This is intended to be called based on human interaction. For example, by a UI button or by a developer who knows or strongly suspects that something is wrong with the network device it needs a reboot. Resetting devices that have been powered off will NOT power them on. Calling this automatically is not recommended especially if it is used as an alternative to the watchdog mechanism. The reason is that it is easier to identify where the device is working than it is to identify every way it can fail. Also, force reset ignores minimum on times since assumption is that if someone wants to reset, they're ready to reset now.","ref":"VintageNet.PowerManager.PMControl.html#force_reset/1"},{"type":"function","title":"VintageNet.PowerManager.PMControl.info/1","doc":"Return information about the specified power manager NOTE: the map returned may change in the future","ref":"VintageNet.PowerManager.PMControl.html#info/1"},{"type":"function","title":"VintageNet.PowerManager.PMControl.pet_watchdog/1","doc":"Pet watchdog Call this whenever the network connection is in a good state. If it has not been called by the watchdog timeout, the device will be rebooted.","ref":"VintageNet.PowerManager.PMControl.html#pet_watchdog/1"},{"type":"function","title":"VintageNet.PowerManager.PMControl.power_off/1","doc":"Power off This is called when VintageNet stops using an interface. The current state in the power management state machine determines how this is handled. For example, the power could already be off.","ref":"VintageNet.PowerManager.PMControl.html#power_off/1"},{"type":"function","title":"VintageNet.PowerManager.PMControl.power_on/1","doc":"Power on This should be called whenever an interface should be powered on. It can be called more than once. If you want the network interface to be on, it is always safe to call this. An internal state machine will ignore redundant calls.","ref":"VintageNet.PowerManager.PMControl.html#power_on/1"},{"type":"function","title":"VintageNet.PowerManager.PMControl.send_message/2","doc":"Send an arbitrary message to the power manager for an interface This will be received by the PowerManager's handle_info/2 callback.","ref":"VintageNet.PowerManager.PMControl.html#send_message/2"},{"type":"function","title":"VintageNet.PowerManager.PMControl.start_link/1","doc":"Start up a server This is intended to be called via VintageNet.PowerManager.Supervisor Arguments: :impl - the module that implements PowerManager :impl_args - arguments to pass to the PowerManager's init/1 call","ref":"VintageNet.PowerManager.PMControl.html#start_link/1"},{"type":"module","title":"VintageNet.PowerManager.Supervisor","doc":"Supervision for all of the power management controllers","ref":"VintageNet.PowerManager.Supervisor.html"},{"type":"function","title":"VintageNet.PowerManager.Supervisor.child_spec/1","doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"VintageNet.PowerManager.Supervisor.html#child_spec/1"},{"type":"function","title":"VintageNet.PowerManager.Supervisor.start_link/1","doc":"","ref":"VintageNet.PowerManager.Supervisor.html#start_link/1"},{"type":"module","title":"VintageNet.PredictableInterfaceName","doc":"Handles predictable interface names by subscribing to the property table and renaming matching interface names based on the configuration in application environment.","ref":"VintageNet.PredictableInterfaceName.html"},{"type":"function","title":"VintageNet.PredictableInterfaceName.built_in?/1","doc":"Return whether an ifname is a built-in one Built-in names start with eth , wlan , etc. and cannot be used as interfaces names when using the predictable networking feature. Examples: iex&gt; PredictableInterfaceName . built_in? ( &quot;wlan0&quot; ) true iex&gt; PredictableInterfaceName . built_in? ( &quot;eth50&quot; ) true iex&gt; PredictableInterfaceName . built_in? ( &quot;lan&quot; ) false","ref":"VintageNet.PredictableInterfaceName.html#built_in?/1"},{"type":"function","title":"VintageNet.PredictableInterfaceName.child_spec/1","doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"VintageNet.PredictableInterfaceName.html#child_spec/1"},{"type":"function","title":"VintageNet.PredictableInterfaceName.precheck/1","doc":"Called before interface configuration. First checks if vintage_net is configured to use predictable interface names, if so checks the given ifname for &quot;common&quot; naming schemes. Instead of a boolean this function returns :ok on success, and {:error, not_predictable_interface_name} on failure. This is done to allow usage in with chains.","ref":"VintageNet.PredictableInterfaceName.html#precheck/1"},{"type":"function","title":"VintageNet.PredictableInterfaceName.start_link/1","doc":"","ref":"VintageNet.PredictableInterfaceName.html#start_link/1"},{"type":"type","title":"VintageNet.PredictableInterfaceName.hw_path_config/0","doc":"hw_path to a user supplied ifname mapping","ref":"VintageNet.PredictableInterfaceName.html#t:hw_path_config/0"},{"type":"module","title":"VintageNet.Resolver.ResolvConf","doc":"Utilities for creating resolv.conf file contents","ref":"VintageNet.Resolver.ResolvConf.html"},{"type":"function","title":"VintageNet.Resolver.ResolvConf.to_config/2","doc":"Convert the name server information to resolv.conf contents","ref":"VintageNet.Resolver.ResolvConf.html#to_config/2"},{"type":"function","title":"VintageNet.Resolver.ResolvConf.to_name_server_list/2","doc":"","ref":"VintageNet.Resolver.ResolvConf.html#to_name_server_list/2"},{"type":"type","title":"VintageNet.Resolver.ResolvConf.additional_name_servers/0","doc":"","ref":"VintageNet.Resolver.ResolvConf.html#t:additional_name_servers/0"},{"type":"type","title":"VintageNet.Resolver.ResolvConf.entry/0","doc":"Name resolver settings for an interface","ref":"VintageNet.Resolver.ResolvConf.html#t:entry/0"},{"type":"type","title":"VintageNet.Resolver.ResolvConf.entry_map/0","doc":"All entries","ref":"VintageNet.Resolver.ResolvConf.html#t:entry_map/0"},{"type":"type","title":"VintageNet.Resolver.ResolvConf.name_server_info/0","doc":"","ref":"VintageNet.Resolver.ResolvConf.html#t:name_server_info/0"},{"type":"module","title":"VintageNet.Route","doc":"Types for handling routing tables","ref":"VintageNet.Route.html"},{"type":"type","title":"VintageNet.Route.default_route/0","doc":"A default route entry The IP address is the default gateway","ref":"VintageNet.Route.html#t:default_route/0"},{"type":"type","title":"VintageNet.Route.entries/0","doc":"A list of routing table entries","ref":"VintageNet.Route.html#t:entries/0"},{"type":"type","title":"VintageNet.Route.entry/0","doc":"A routing table entry This can be turned into real Linux IP routing table entry.","ref":"VintageNet.Route.html#t:entry/0"},{"type":"type","title":"VintageNet.Route.local_route/0","doc":"A local route entry This is for routing packets to the LAN","ref":"VintageNet.Route.html#t:local_route/0"},{"type":"type","title":"VintageNet.Route.metric/0","doc":"Metric (priority) for a routing table entry","ref":"VintageNet.Route.html#t:metric/0"},{"type":"type","title":"VintageNet.Route.route_metric_fun/0","doc":"Compute a route metric value from information about the interface See VintageNet.Route.DefaultMetric.compute_metric/2 for an example. This can be set using the :route_metric_fun application environment key.","ref":"VintageNet.Route.html#t:route_metric_fun/0"},{"type":"type","title":"VintageNet.Route.rule/0","doc":"An IP route rule If the source address matches the 3rd element, then use the routing table specified by the 2nd element.","ref":"VintageNet.Route.html#t:rule/0"},{"type":"type","title":"VintageNet.Route.table_index/0","doc":"Linux routing table index :main is table 254, :local is table 255. :default is normally the same as :main .","ref":"VintageNet.Route.html#t:table_index/0"},{"type":"module","title":"VintageNet.Route.Calculator","doc":"This module computes the desired routing table contents It's used by the RouteManager to update the Linux routing tables when interfaces come online or change state. See the RouteManager docs for a discussion of how routes are configured. The functions in this module have no side effects so that it's easier to test that routing scenarios result in correct Linux routing table configurations.","ref":"VintageNet.Route.Calculator.html"},{"type":"function","title":"VintageNet.Route.Calculator.compute/3","doc":"Compute a Linux routing table configuration The entries are ordered so that List.myers_difference/2 can be used to minimize the routing table changes.","ref":"VintageNet.Route.Calculator.html#compute/3"},{"type":"function","title":"VintageNet.Route.Calculator.init/0","doc":"Initialize state carried between calculations","ref":"VintageNet.Route.Calculator.html#init/0"},{"type":"function","title":"VintageNet.Route.Calculator.rule_table_index_range/0","doc":"Return the table indices used for routing based on source IP.","ref":"VintageNet.Route.Calculator.html#rule_table_index_range/0"},{"type":"type","title":"VintageNet.Route.Calculator.interface_infos/0","doc":"","ref":"VintageNet.Route.Calculator.html#t:interface_infos/0"},{"type":"type","title":"VintageNet.Route.Calculator.table_indices/0","doc":"","ref":"VintageNet.Route.Calculator.html#t:table_indices/0"},{"type":"module","title":"VintageNet.Route.DefaultMetric","doc":"Default module for prioritizing network interfaces The priority order is: Internet-connected interfaces are chosen before LAN-connected interfaces Wired Ethernet, then wifi, then mobile and then any other interfaces The interface's weight is used to resolve ties. By default, the weight is derived from the interfaces index. E.g., eth0 's weight is 0 (highest priority) and eth1 's weight is 1 (next highest)","ref":"VintageNet.Route.DefaultMetric.html"},{"type":"function","title":"VintageNet.Route.DefaultMetric.compute_metric/2","doc":"Compute the routing metric for an interface with a status This uses the prioritization list to figure out what number should be used for the Linux routing table metric. It could also be :disabled to indicate that a route shouldn't be added to the Linux routing tables at all.","ref":"VintageNet.Route.DefaultMetric.html#compute_metric/2"},{"type":"module","title":"VintageNet.Route.IPRoute","doc":"This module knows how to invoke the ip command to modify the Linux routing tables","ref":"VintageNet.Route.IPRoute.html"},{"type":"function","title":"VintageNet.Route.IPRoute.add_default_route/4","doc":"Add a default route","ref":"VintageNet.Route.IPRoute.html#add_default_route/4"},{"type":"function","title":"VintageNet.Route.IPRoute.add_local_route/5","doc":"Add a local route","ref":"VintageNet.Route.IPRoute.html#add_local_route/5"},{"type":"function","title":"VintageNet.Route.IPRoute.add_rule/2","doc":"Add a source IP address -&gt; routing table rule","ref":"VintageNet.Route.IPRoute.html#add_rule/2"},{"type":"function","title":"VintageNet.Route.IPRoute.clear_a_local_route/1","doc":"Clear one local route generically","ref":"VintageNet.Route.IPRoute.html#clear_a_local_route/1"},{"type":"function","title":"VintageNet.Route.IPRoute.clear_a_local_route/5","doc":"Clear one local route","ref":"VintageNet.Route.IPRoute.html#clear_a_local_route/5"},{"type":"function","title":"VintageNet.Route.IPRoute.clear_a_route/0","doc":"Clear one default route out of the main table for any interface","ref":"VintageNet.Route.IPRoute.html#clear_a_route/0"},{"type":"function","title":"VintageNet.Route.IPRoute.clear_a_route/2","doc":"Clear one default route that goes to the specified interface","ref":"VintageNet.Route.IPRoute.html#clear_a_route/2"},{"type":"function","title":"VintageNet.Route.IPRoute.clear_a_rule/1","doc":"Clear out one rule","ref":"VintageNet.Route.IPRoute.html#clear_a_rule/1"},{"type":"function","title":"VintageNet.Route.IPRoute.clear_all_routes/0","doc":"Clear all routes on all interfaces","ref":"VintageNet.Route.IPRoute.html#clear_all_routes/0"},{"type":"function","title":"VintageNet.Route.IPRoute.clear_all_rules/1","doc":"Clear all rules that select the specified table or tables","ref":"VintageNet.Route.IPRoute.html#clear_all_rules/1"},{"type":"module","title":"VintageNet.Route.InterfaceInfo","doc":"Routing information for an interface","ref":"VintageNet.Route.InterfaceInfo.html"},{"type":"type","title":"VintageNet.Route.InterfaceInfo.t/0","doc":"Routing information :default_gateway - default gateway IP address or nil if there isn't one :ip_subnets - zero or more IP addresses and prefix lengths for what's on this LAN :weight - a value to pass on when calculating the routing table metric for weighting an interface over another one :interface_type - a rough categorization of the interface between :ethernet , :wifi , :cellular , etc. based on the name. See VintageNet.Interface.NameUtilities . :status - whether the interface is :disconnected , :lan , or :internet","ref":"VintageNet.Route.InterfaceInfo.html#t:t/0"},{"type":"type","title":"VintageNet.Route.InterfaceInfo.weight/0","doc":"A weight that can be used to differentiate two interfaces that would otherwise be the same priority Lower weights are higher priority.","ref":"VintageNet.Route.InterfaceInfo.html#t:weight/0"},{"type":"module","title":"VintageNet.Route.Properties","doc":"This module contains helpers for updating the global routing properties. These include: [&quot;available_interfaces&quot;] [&quot;connection&quot;]","ref":"VintageNet.Route.Properties.html"},{"type":"function","title":"VintageNet.Route.Properties.update_available_interfaces/1","doc":"Update the available_interfaces property based on the low level routes This function orders interfaces based on metric just like Linux does","ref":"VintageNet.Route.Properties.html#update_available_interfaces/1"},{"type":"function","title":"VintageNet.Route.Properties.update_best_connection/1","doc":"Update the overall connection status :disconnected &lt; :lan &lt; :internet","ref":"VintageNet.Route.Properties.html#update_best_connection/1"},{"type":"function","title":"VintageNet.Route.Properties.update_connection_status/1","doc":"Update every interface's connection status","ref":"VintageNet.Route.Properties.html#update_connection_status/1"},{"type":"module","title":"VintageNet.RouteManager","doc":"This module manages the default route. Devices with more than one network interface may have more than one way of reaching the Internet. The routing table decides which interface an IP packet should use by looking at the &quot;default route&quot; entries. One interface is chosen. Since not all interfaces are equal, we'd like Linux to pick the fastest and lowest latency one. for example, one could prefer wired Ethernet over WiFi and prefer WiFi over a cellular connection. This module lets you specify an ordering for interfaces and sets up the routes based on this ordering. This module also handles networking failures. One failure that Linux can't figure out on its own is whether an interface can reach the Internet. Internet reachability is handled elsewhere like in the ConnectivityChecker module. This module should be told reachability status so that it can properly order default routes so that the best reachable interface is used. IMPORTANT: This module uses priority-based routing. Make sure the following kernel options are enabled: CONFIG_IP_ADVANCED_ROUTER=y CONFIG_IP_MULTIPLE_TABLES=y","ref":"VintageNet.RouteManager.html"},{"type":"function","title":"VintageNet.RouteManager.child_spec/1","doc":"Returns a specification to start this module under a supervisor. See Supervisor .","ref":"VintageNet.RouteManager.html#child_spec/1"},{"type":"function","title":"VintageNet.RouteManager.clear_route/1","doc":"Clear out the default gateway for an interface.","ref":"VintageNet.RouteManager.html#clear_route/1"},{"type":"function","title":"VintageNet.RouteManager.refresh_route_metrics/0","doc":"Refresh route metrics for all interfaces.","ref":"VintageNet.RouteManager.html#refresh_route_metrics/0"},{"type":"function","title":"VintageNet.RouteManager.set_connection_status/3","doc":"Set the connection status on an interface. Changing the connection status can re-prioritize routing. The specified interface doesn't need to have a default route.","ref":"VintageNet.RouteManager.html#set_connection_status/3"},{"type":"function","title":"VintageNet.RouteManager.set_route/3","doc":"Set the default route for an interface. This replaces any existing routes on that interface","ref":"VintageNet.RouteManager.html#set_route/3"},{"type":"function","title":"VintageNet.RouteManager.start_link/1","doc":"Start the route manager Options: :route_metric_fun - a 2-arity function that takes a ifname and VintageNet.Route.InterfaceInfo and returns VintageNet.Route.metric()","ref":"VintageNet.RouteManager.html#start_link/1"},{"type":"function","title":"VintageNet.RouteManager.stop/0","doc":"Stop the route manager.","ref":"VintageNet.RouteManager.html#stop/0"},{"type":"behaviour","title":"VintageNet.Technology","doc":"Technologies define how network interface types work VintageNet comes with several built-in technologies, but more can be added or existing ones modified by implementing the Technology behaviour.","ref":"VintageNet.Technology.html"},{"type":"callback","title":"VintageNet.Technology.check_system/1","doc":"Check that the system has all of the required programs for this technology This is intended to help identify missing programs without configuring a network.","ref":"VintageNet.Technology.html#c:check_system/1"},{"type":"callback","title":"VintageNet.Technology.ioctl/3","doc":"Handle an ioctl that has been requested on the network interface The function runs isolated in its own process and only one ioctl is guaranteed to be running at a time. VintageNet will handle crashes and hangs and unceremoniously kill the ioctl if the user changes their mind and reconfigures the network interface. Ioctl support is optional. Examples of ioctl s include: :scan - scan for WiFi networks :statistics - return a map of network statistics","ref":"VintageNet.Technology.html#c:ioctl/3"},{"type":"callback","title":"VintageNet.Technology.normalize/1","doc":"Normalize a configuration Technologies use this to update input configurations to a canonical representation. This includes things like inserting default fields, converting IP addresses passed in as strings to tuples, and deriving parameters so that they need not be derived again in the future. Configuration errors raise exceptions.","ref":"VintageNet.Technology.html#c:normalize/1"},{"type":"callback","title":"VintageNet.Technology.to_raw_config/3","doc":"Convert a technology-specific configuration to one for VintageNet The config is the normalized configuration map ( normalize/1 will have been called at some point so the technology does not need to call it again). The opts parameter contains VintageNet's application environment. This contains potentially useful file paths and other information. Configuration errors raise exceptions. Errors should be infrequent, though, since VintageNet will call normalize/1 first and expects most errors to be caught by it.","ref":"VintageNet.Technology.html#c:to_raw_config/3"},{"type":"module","title":"VintageNet.Technology.Null","doc":"An interface with this technology is unconfigured","ref":"VintageNet.Technology.Null.html"},{"type":"extras","title":"README","doc":"NOTE: If you've been using vintage_net v0.6.x or earlier, we split out network technology support out to separate libraries in v0.7.0 . You'll need to add those libraries to your mix dependency list and rename some atoms. Configurations stored on deployed devices will be automatically updated. See the v0.7.0 release notes for details. VintageNet is network configuration library built specifically for Nerves Project devices. It has the following features: Ethernet and WiFi support included. Extendible to other technologies Default configurations specified in your Application config Runtime updates to configurations are persisted and applied on next boot (configurations are obfuscated by default to hide WiFi passphrases) Simple subscription to network status change events Connect to multiple networks at a time and prioritize which interfaces are used (Ethernet over WiFi over cellular) Internet connection monitoring and failure detection Predictable network interface names TL;DR: Don't care about any of this and just want the string to copy/paste to set up networking? See the VintageNet Cookbook . The following network configurations are supported: [x] Wired Ethernet, IPv4 DHCP [x] Wired Ethernet, IPv4 static IP [x] WiFi password-less and WEP [x] WPA2 PSK and EAP [x] USB gadget mode Ethernet, IPv4 DHCP server to supply host IP address [x] Cellular networks (see vintage_net_qmi and vintage_net_mobile for details) [x] WiFi AP mode [ ] IPv6 - Partially supported. SLAAC configuration works. vintage_net takes a different approach to networking from nerves_network . Its focus is on building and applying network configurations. Where nerves_network provided configurable state machines, vintage_net turns human-readable configurations into everything from configuration files and calls to ip to starting up networking GenServers and routing table updates. This makes it easier to add support for new network technologies and features. While Elixir and Erlang were great to implement network protocols in, it was frequently more practical to reuse embedded Linux implementations. Importantly, though, vintage_net monitors Linux daemons under its OTP supervision tree so failures on both the &quot;C&quot; and Elixir sides propagate in the expected ways. Another important difference is that VintageNet doesn't attempt to make incremental modifications to configurations. It completely tears down an interface's connection and then brings up new configurations in a fresh state. Network reconfiguration is assumed to be an infrequent event so while this can cause a hiccup in the network connectivity, it removes state machine code that made nerves_network hard to maintain.","ref":"readme.html"},{"type":"extras","title":"README - Installation","doc":"First, if you're modifying an existing project, you will need to remove nerves_network and nerves_init_gadget . vintage_net doesn't work with either of them. You'll get an error if any project references those packages. There are two routes to integrating vintage_net : Use nerves_pack . nerves_pack is like nerves_init_gadget , but for vintage_net . Copy and paste from the Nerves hello WiFi example The next step is to make sure that your Nerves system is compatible. The official Nerves systems released after 12/11/2019 work without modification. If rolling your own Nerves port, you will need the following Linux kernel options enabled: CONFIG_IP_ADVANCED_ROUTER=y CONFIG_IP_MULTIPLE_TABLES=y Then make sure that you have the following Busybox options enabled: CONFIG_IFCONFIG=y - ifconfig ifconfig CONFIG_UDHCPC=y - udhcpc DHCP Client CONFIG_UDHCPD=y - udhcpd DHCP Server (optional) Finally, you'll need to choose what network connection technologies that you want available in your firmware. If using nerves_pack , you'll get support for wired Ethernet, WiFi, and USB gadget networking automatically. Otherwise, add one or more of the following to your dependency list: vintage_net_ethernet - Standard wired Ethernet vintage_net_wifi - Client configurations for 802.11 WiFi vintage_net_direct - Direct connections like those used for USB gadget vintage_net_qmi - Support USB-connected cellular modems vintage_net_mobile - Support UART-connected cellular modems","ref":"readme.html#installation"},{"type":"extras","title":"README - Configuration","doc":"VintageNet has many application configuration keys. Most defaults are fine. At a minimum, you'll want to specify a default configuration and default regulatory domain if using WiFi. In your main config.exs , add the following: config :vintage_net , regulatory_domain : &quot;US&quot; , config : [ { &quot;eth0&quot; , %{ type : VintageNetEthernet , ipv4 : %{ method : :dhcp } } } , { &quot;wlan0&quot; , %{ type : VintageNetWiFi } } ] This sets the regulatory domain to the US (set to your ISO 3166-1 alpha-2 country code . This code is passed on to the drivers for WiFi and other wireless networking technologies so that they comply with local regulations. If you need a global default, set to &quot;00&quot; or don't set at all. Unfortunately, this may mean that an access point isn't visible if it is running on a frequency that's allowed in your country, but not globally. The config section is a list of network configurations. The one shown above configures DHCP on wired Ethernet and minimally starts up a WiFi LAN so that it's possible to scan for networks. The typical setup is to provide generic defaults here. Static IP addresses, WiFi SSIDs and credentials are more appropriately configured at run-time. VintageNet persists configurations too. Details on network configuration are described later. The following table describes the other application config keys. Key Description config A list of default network configurations tmpdir Path to a temporary directory for VintageNet udhcpc_handler Module for handling notifications from udhcpc resolvconf Path to /etc/resolv.conf persistence Module for persisting network configurations persistence_dir Path to a directory for storing persisted configurations persistence_secret A 16-byte secret or a function or MFArgs (module, function, arguments tuple) for getting a secret internet_host_list IP address or hostnames and ports to try to connect to for checking Internet connectivity. Defaults to a list of large public DNS providers. E.g., [{{1, 1, 1, 1}, 53}] . regulatory_domain ISO 3166-1 alpha-2 country ( 00 for global, US , etc.) additional_name_servers List of DNS servers to be used in addition to any supplied by an interface. E.g., [{1, 1, 1, 1}, {8, 8, 8, 8}] route_metric_fun Customize how network interfaces are prioritized. See VintageNet.Route.DefaultMetric.compute_metric/2","ref":"readme.html#configuration"},{"type":"extras","title":"README - Network interface configuration","doc":"VintageNet supports several network technologies out of the box and third-party libraries can provide more via the VintageNet.Technology behaviour. Configurations are Elixir maps. These are specified in three places: The vintage_net application config (e.g., your config.exs ) Locally saved configuration (see the VintageNet.Persistence behaviour for replacing the default) Calling VintageNet.configure/2 to change the configuration at run-time When vintage_net starts, it applies saved configurations first and if any thing is wrong with those configs, it reverts to the application config. A good practice is to have safe defaults for all network interfaces in the application config. The only required key in the configuration maps is :type . All other keys follow from the type. :type should be set to a module that implements the VintageNet.Technology behaviour. The following are common technologies: VintageNetEthernet - Standard wired Ethernet VintageNetWiFi - Client configurations for 802.11 WiFi VintageNetDirect - Direct connections like those used for USB gadget connections VintageNet.Technology.Null - An empty configuration useful for turning off a configuration See the links above for specific documentation.","ref":"readme.html#network-interface-configuration"},{"type":"extras","title":"README - Persistence","doc":"By default, VintageNet stores network configuration to disk. If you are migrating from nerves_network you may already have a persistence implementation. To disable the default persistence, configure vintage_net as follows: config :vintage_net , persistence : VintageNet.Persistence.Null","ref":"readme.html#persistence"},{"type":"extras","title":"README - Debugging","doc":"Debugging networking issues is not fun. When you're starting out with vintage_net , it is highly recommended to connect to your target using a method that doesn't require networking to work. This could be a UART connection to an IEx console on a Nerves device or maybe just hooking up a keyboard and monitor. If having trouble, first check VintageNet.info() to verify the configuration and connection status: iex&gt; VintageNet . info VintageNet 0.3 . 0 All interfaces : [ &quot;eth0&quot; , &quot;lo&quot; , &quot;tap0&quot; , &quot;wlan0&quot; ] Available interfaces : [ &quot;eth0&quot; , &quot;wlan0&quot; ] Interface eth0 Type : VintageNetEthernet Present : true State : :configured Connection : :internet Configuration : %{ ipv4 : %{ method : :dhcp } , type : VintageNetEthernet } Interface wlan0 Type : VintageNetWiFi Present : true State : :configured Connection : :internet Configuration : %{ ipv4 : %{ method : :dhcp } , type : VintageNetWiFi , wifi : %{ key_mgmt : :wpa_psk , mode : :infrastructure , psk : &quot;******&quot; , ssid : &quot;MyLAN&quot; } } If you're using Toolshed , try running the following: iex&gt; ifconfig lo : flags = [ :up , :loopback , :running ] inet 127.0 . 0.1 netmask 255.0 . 0.0 inet :: 1 netmask ffff :ffff :ffff :ffff :ffff :ffff :ffff :ffff hwaddr 00 : 00 : 00 : 00 : 00 : 00 eth0 : flags = [ :up , :broadcast , :running , :multicast ] inet 192.168 . 9.131 netmask 255.255 . 255.0 broadcast 192.168 . 9.255 inet fe80 :: 6264 : 5 ff :fee1 : 4045 netmask ffff :ffff :ffff :ffff :: hwaddr 60 : 64 : 05 :e1 : 40 : 45 wlan0 : flags = [ :up , :broadcast , :running , :multicast ] inet 192.168 . 9.175 netmask 255.255 . 255.0 broadcast 192.168 . 9.255 inet fe80 :: 20 c :e7ff :fe11 : 3 d46 netmask ffff :ffff :ffff :ffff :: hwaddr 00 : 0 c :e7 : 11 : 3 d : 46 Or ping: iex&gt; ping &quot;nerves-project.com&quot; Press enter to stop Response from nerves - project . com ( 96.126 . 123.244 ) : time = 48.87 ms Response from nerves - project . com ( 96.126 . 123.244 ) : time = 42.856 ms Response from nerves - project . com ( 96.126 . 123.244 ) : time = 43.097 ms You can also specify an interface to use with ping : iex&gt; ping &quot;nerves-project.com&quot; , ifname : &quot;wlan0&quot; Press enter to stop Response from nerves - project . com ( 96.126 . 123.244 ) : time = 57.817 ms Response from nerves - project . com ( 96.126 . 123.244 ) : time = 46.796 ms iex&gt; ping &quot;nerves-project.com&quot; , ifname : &quot;eth0&quot; Press enter to stop Response from nerves - project . com ( 96.126 . 123.244 ) : time = 47.923 ms Response from nerves - project . com ( 96.126 . 123.244 ) : time = 48.688 ms If it looks like nothing is working, check the logs. On Nerves devices, this is frequently done by calling RingLogger.next or RingLogger.attach . At a last resort, please open a GitHub issue. We would be glad to help. We only have one ask and that is that you get us started with an improvement to our documentation or code so that the next person to run into the issue will have an easier time. Thanks!","ref":"readme.html#debugging"},{"type":"extras","title":"README - Properties","doc":"VintageNet maintains a key/value store for retrieving information on networking information: iex&gt; VintageNet . get ( [ &quot;interface&quot; , &quot;eth0&quot; , &quot;connection&quot; ] ) :internet iex&gt; VintageNet . get_by_prefix ( [ ] ) [ { [ &quot;interface&quot; , &quot;eth0&quot; , &quot;connection&quot; ] , :internet } , { [ &quot;interface&quot; , &quot;eth0&quot; , &quot;state&quot; ] , :configured } , { [ &quot;interface&quot; , &quot;eth0&quot; , &quot;type&quot; ] , VintageNetEthernet } , { [ &quot;interface&quot; , &quot;wlan0&quot; , &quot;connection&quot; ] , :internet } , { [ &quot;interface&quot; , &quot;wlan0&quot; , &quot;state&quot; ] , :configured } , { [ &quot;interface&quot; , &quot;wlan0&quot; , &quot;type&quot; ] , VintageNetWiFi } ] You can also subscribe to keys and receive a message every time it or one its child keys changes: iex&gt; VintageNet . subscribe ( [ &quot;interface&quot; , &quot;eth0&quot; ] ) :ok iex&gt; flush { VintageNet , [ &quot;interface&quot; , &quot;eth0&quot; , &quot;state&quot; ] , :configuring , :configured , %{ old_timestamp : 123456 , new_timestamp : 124456 } } The message format is {VintageNet, name, old_value, new_value, metadata} Metadata fields include at least the following: :old_timestamp - the timestamp for when the property first had the old_value :new_timestamp - the timestamp when the property changed from the old_value to the new_value Timestamps are all captured by calling System.monotonic_time/0 so they're in :native time units. Use System.convert_time_unit/3 to convert to the usual time units. Global properties Property Values Description available_interfaces [eth0, ...] Currently available network interfaces in priority order. E.g., the first one is used by default connection :disconnected , :lan , :internet The overall network connection status. This is the best status of all interfaces. name_servers [%{address: ..., from: []}] Name server addresses and where VintageNet learned about them Common network interface properties All network interface properties can be found under [&quot;interface&quot;, ifname] in the PropertyTable . The following table lists out properties common to all interfaces: Property Values Description type VintageNetEthernet , etc. The type of the interface config %{...} The configuration for this interface state :configured , :configuring , etc. The state of the interface from VintageNet 's point of view. hw_path &quot;/devices/platform/ocp/4a100000.ethernet&quot; This is how Linux internally views the connections going to the interface. connection :disconnected , :lan , :internet This provides a determination of the Internet connection status lower_up true or false This indicates whether the physical layer is &quot;up&quot;. E.g., a cable is connected or WiFi associated mac_address &quot;11:22:33:44:55:66&quot; The interface's MAC address as a string addresses [address_info] This is a list of all of the addresses assigned to this interface dhcp_options %{...} When DHCP is in use, the processed response information and options is stored here. See VintageNet.DHCP.Options.t/0 Specific types of interfaces provide more parameters. Predictable network interface names When using more than one of the same type of interface, it's possible for Linux to reorder their naming. For example, if you have two USB WiFi adapters, one will be named wlan0 and the other wlan1 . Which one is first depends on things like when the adapter is found and when kernel modules are loaded. This can vary between boots and cause a lot of confusion. The solution is to rename network interfaces based on characteristics of the interface - such as how it's connected. Then application software refers to the new name rather than names like wlan0 . This is a common problem, and VintageNet provides support for automatically renaming network interfaces. If you're used to systemd 's approach to naming interfaces, be aware that VintageNet's approach is different: systemd has an algorithm for generating names (e.g., enp4s0 ) automatically. VintageNet requires you to provide the names to use (e.q., internet0 , lan0 , etc.) and how they map to hardware. If VintageNet is confronted with a network interface that is connected in a way that it doesn't know about, it will do nothing. IMPORTANT: Do not mix and match predictable interface names and non-predictable interface names ( wlan* , eth* , usb* , wwan* ). It is confusing and VintageNet will fight you. Before switching to predictable names, find out how your network interfaces are connected. For example, this device has an Ethernet interface and two USB WiFi dongles: iex&gt; VintageNet . match ( [ &quot;interface&quot; , :_ , &quot;hw_path&quot; ] ) [ { [ &quot;interface&quot; , &quot;eth0&quot; , &quot;hw_path&quot; ] , &quot;/devices/platform/ocp/4a100000.ethernet&quot; } , { [ &quot;interface&quot; , &quot;lo&quot; , &quot;hw_path&quot; ] , &quot;/devices/virtual&quot; } , { [ &quot;interface&quot; , &quot;wlan0&quot; , &quot;hw_path&quot; ] , &quot;/devices/platform/ocp/47400000.usb/47401c00.usb/musb-hdrc.1/usb2/2-1/2-1:1.0&quot; } , { [ &quot;interface&quot; , &quot;wlan1&quot; , &quot;hw_path&quot; ] , &quot;/devices/platform/ocp/47400000.usb/47401400.usb/musb-hdrc.0/usb1/1-1/1-1:1.4&quot; } ] Now update your config.exs with the mappings with the :ifnames key. Be sure to also update the default configuration with the new interface names. Continuing the example, imagine that one WiFi adapter supports 802.11 meshing and it's guaranteed to be in one USB port on the device. The other USB port can have any of a few types of USB WiFi modules. We need to use predictable naming in this case so that meshing is only setup on the adapter that supports it. config :vintage_net , ifnames : [ %{ hw_path : &quot;/devices/platform/ocp/4a100000.ethernet&quot; , ifname : &quot;ethernet0&quot; } , %{ hw_path : &quot;/devices/platform/ocp/47400000.usb/47401c00.usb/musb-hdrc.1/usb2/2-1/2-1:1.0&quot; , ifname : &quot;primary_wifi&quot; } , %{ hw_path : &quot;/devices/platform/ocp/47400000.usb/47401400.usb/musb-hdrc.0/usb1/1-1/1-1:1.4&quot; , ifname : &quot;mesh_wifi&quot; } ] , config : [ { &quot;ethernet0&quot; , %{ type : VintageNetEthernet } } , { &quot;primary_wifi&quot; , %{ type : VintageNetWiFi } } , { &quot;mesh_wifi&quot; , %{ type : VintageNetWiFi } } ] IMPORTANT: VintageNet has rules about renaming interfaces to prevent confusing errors. Below is a list of reasons it will not rename an interface hw_path matches /devices/virtual (such as lo0 , ppp0 etc.) A second interface's hw_path matches an interface that has already been renamed. This should never happen.","ref":"readme.html#properties"},{"type":"extras","title":"README - Internet connectivity checks","doc":"VintageNet can check whether a network interface can reach the Internet. This has a few uses: Selecting which network interface is used when a device has more than one. A common example is a device with a backup cellular connection. Automatically recovering a network interface that has lost connectivity. Some times bouncing the network interface actually works, so doing this automatically can sometimes revive a remote device. Letting the application know the status of the network connection to provide more helpful information about what's happening. The logic for declaring that the Internet is available is: Is there a TCP socket in use on the network interface that has sent and received data from a host that's not on the same subnet? If yes, then the device is Internet-connected. Get the list of Internet servers to check. See below for the list. Resolve any domain names in the list. If DNS isn't working, remove them from the list. Pick a random IP address from the remaining list and &quot;ping&quot; it. Technically, VintageNet tries to connect over TCP to a specified port, and if it either connects successfully or gets a port closed response, then the device is Internet-connected. Wait a bit and then go back to step 1. The list of Internet servers to check is critically important. VintageNet uses the :internet_host_list key in the application environment for this. The default setting has many popular name servers in it. The idea being that if you can't reach a name server, the Internet probably isn't going to work well. If you are deploying to locations with locked down networks, you'll find that the default setting to test name servers won't work. It is not uncommon to find a network that blocks popular name servers like 8.8.8.8. The recommendation is to set the :internet_host_list to include your backend server. If VintageNet can reach it, then presumably your application works and having VintageNet declare the internet reachable via that network interface is correct. For example, config :vintage_net , internet_host_list : [ { &quot;abcdefghijk-ats.iot.us-east-1.amazonaws.com&quot; , 443 } ] The use of the connectivity checker is specified by the technology. Both the VintageNetEthernet and VintageNetWiFi use the internet connectivity checker. This is selected by adding the VintageNet.Connectivity.InternetChecker GenServer to the :child_specs configuration returned by the technology. E.g., child_specs: [{VintageNet.Connectivity.InternetChecker, &quot;eth0&quot;}] . Most users do not need to be concerned about this.","ref":"readme.html#internet-connectivity-checks"},{"type":"extras","title":"README - Power Management","doc":"Some devices require additional work to be done for them to become available. Examples of this are: Setting a GPIO to enable power to the module Loading a Linux kernel module that is not automatically loaded via the default mechanisms Running usb_modeswitch to change the USB interface to the appropriate state Performing an initialization step such as loading firmware Similarly, when the network interface is no longer being used, it can be nice to undo any steps above. This process is referred to as power management in VintageNet even though the implementation may not actually affect power use. To use it, implement the VintageNet.PowerManager behaviour and register the implementation in your config.exs . Additionally, VintageNet runs a watchdog-like service for network devices that supply VintageNet.PowerManager implementations. If the watchdog is not pet within the timeout period (user-specified and defaults to 60 seconds), VintageNet powers the device off and and on. The VintageNet power management code supports mandatory minimum on and off times to prevent damage to hardware and also minimize pointless power cycling of hardware. While many network devices are fairly reliable and powering off and on seems unnecessary, it can save a trip to the field or a full device reboot. VintageNet.info/1 shows the power management state for network interfaces that are using this feature.","ref":"readme.html#power-management"},{"type":"extras","title":"VintageNet Cookbook","doc":"Not sure what to pass to vintage_net ? Take a look below for example configurations.","ref":"cookbook.html"},{"type":"extras","title":"VintageNet Cookbook - Compile-time vs. run-time","doc":"The examples below all show the options to pass. Where you copy those depends on whether you want the configuration to be a built-in default (i.e., compile-time) or whether you want to change it at run-time. For compile-time, add something like the following to your config.exs : config :vintage_net , config : [ { &quot;eth0&quot; , %{ type : VintageNetEthernet , ipv4 : %{ method : :dhcp } } } , ] But replace &quot;eth0&quot; with the interface and the map with the desired configuration from below. For run-time, call VintageNet.configure like this: VintageNet . configure ( &quot;eth0&quot; , %{ type : VintageNetEthernet , ipv4 : %{ method : :dhcp } } ) To see the current configuration at an IEx prompt, type: iex&gt; VintageNet . info","ref":"cookbook.html#compile-time-vs-run-time"},{"type":"extras","title":"VintageNet Cookbook - Network interface names","doc":"In order to configure a network interface, you will need to know its name. vintage_net passes names through from Nerves or embedded Linux depending on where it's being run. The following names are common: &quot;eth0&quot; - The first wired Ethernet interface &quot;wlan0&quot; - The first WiFi interface &quot;usb0&quot; - The first virtual Ethernet interface over a USB cable The operating system assigns network interface names as it discovers them. If you're running on a device with multiple of the same type of interface, the device names may be renamed to make them deterministic. An example is &quot;enp6s0&quot; where the p6 and s0 indicate where the adapter and Ethernet connector location. Running ifconfig on Linux and Nerves can help find these if you are unsure.","ref":"cookbook.html#network-interface-names"},{"type":"extras","title":"VintageNet Cookbook - Wired Ethernet","doc":"To use, make sure that you're either using nerves_pack or have :vintage_net_ethernet in your deps: { :vintage_net_ethernet , &quot;~&gt; 0.8&quot; } Wired Ethernet with DHCP This is regular wired Ethernet - nothing fancy: %{ type : VintageNetEthernet , ipv4 : %{ method : :dhcp } } Wired Ethernet with a static IP Update the parameters below as appropriate: %{ type : VintageNetEthernet , ipv4 : %{ method : :static , address : &quot;192.168.9.232&quot; , prefix_length : 24 , gateway : &quot;192.168.9.1&quot; , name_servers : [ &quot;1.1.1.1&quot; ] } } See VintageNet.IP.IPv4Config for other options. If you're interfacing with other Erlang and Elixir libraries, you may find passing IP tuples more convenient than passing strings. That works too.","ref":"cookbook.html#wired-ethernet"},{"type":"extras","title":"VintageNet Cookbook - WiFi","doc":"To use, make sure that you're either using nerves_pack or have :vintage_net_wifi in your deps: { :vintage_net_wifi , &quot;~&gt; 0.8&quot; } Normal password-protected WiFi (WPA2 PSK) Most password-protected home networks use WPA2 authentication and pre-shared keys. %{ type : VintageNetWiFi , vintage_net_wifi : %{ networks : [ %{ key_mgmt : :wpa_psk , ssid : &quot;my_network_ssid&quot; , psk : &quot;a_passphrase_or_psk&quot; } ] } , ipv4 : %{ method : :dhcp } , } Here are example parameters for an static IP address. %{ type : VintageNetWiFi , vintage_net_wifi : %{ networks : [ %{ key_mgmt : :wpa_psk , ssid : &quot;my_network_ssid&quot; , psk : &quot;a_passphrase_or_psk&quot; } ] } , ipv4 : %{ method : :static , address : &quot;192.168.9.232&quot; , prefix_length : 24 , gateway : &quot;192.168.9.1&quot; , name_servers : [ &quot;1.1.1.1&quot; ] } } If you're regularly switching between multiple networks, you can list them all under the :networks key. Note that it's currently not possible to mix networks that require static IP addresses with those that use DHCP. %{ type : VintageNetWiFi , vintage_net_wifi : %{ networks : [ %{ key_mgmt : :wpa_psk , ssid : &quot;my_network_ssid&quot; , psk : &quot;a_passphrase_or_psk&quot; } , %{ key_mgmt : :wpa_psk , ssid : &quot;another_ssid&quot; , psk : &quot;a_passphrase_or_psk&quot; } , ... ] } , ipv4 : %{ method : :dhcp } , } Enterprise WiFi (PEAPv0/EAP-MSCHAPV2) Protected EAP (PEAP) is a common authentication protocol for enterprise WiFi networks. %{ type : VintageNetWiFi , vintage_net_wifi : %{ networks : [ %{ key_mgmt : :wpa_eap , ssid : &quot;my_network_ssid&quot; , identity : &quot;username&quot; , password : &quot;password&quot; , eap : &quot;PEAP&quot; , phase2 : &quot;auth=MSCHAPV2&quot; } ] } , ipv4 : %{ method : :dhcp } } Enterprise WiFi (EAP-TLS) TBD Hidden WiFi networks If the access point has been configured to not advertise a network, VintageNetWiFi won't find it. It has to explicitly be told to search for it. Add scan_ssid: 1 to the configuration to do this. For example, %{ type : VintageNetWiFi , vintage_net_wifi : %{ networks : [ %{ key_mgmt : :wpa_psk , ssid : &quot;my_network_ssid&quot; , psk : &quot;a_passphrase_or_psk&quot; , scan_ssid : 1 } ] } , ipv4 : %{ method : :dhcp } , } Access point WiFi Some WiFi modules can be run in access point mode. This makes it possible to create configuration wizards and captive portals. Configuration of this is more involved. Here is a basic configuration: %{ type : VintageNetWiFi , vintage_net_wifi : %{ networks : [ %{ mode : :ap , ssid : &quot;test ssid&quot; , key_mgmt : :none } ] } , ipv4 : %{ method : :static , address : &quot;192.168.24.1&quot; , netmask : &quot;255.255.255.0&quot; } , dhcpd : %{ start : &quot;192.168.24.2&quot; , end : &quot;192.168.24.10&quot; , options : %{ dns : [ &quot;1.1.1.1&quot; , &quot;1.0.0.1&quot; ] , subnet : &quot;255.255.255.0&quot; , router : [ &quot;192.168.24.1&quot; ] } } } If you want to use WPA2 on your access point, make the networks map look like this: %{ mode : :ap , key_mgmt : :wpa_psk , proto : &quot;RSN&quot; , pairwise : &quot;CCMP&quot; , group : &quot;CCMP&quot; , ssid : &quot;test ssid&quot; , psk : &quot;secret123&quot; } The proto: &quot;RSN&quot; entry is important since the wpa_supplicant default is WPA and not WPA2 . See the vintage_net_wizard for an example of a project that uses AP mode and a web server for WiFi configuration. Advanced Use of WPA Supplicant VintageNetWifi supports an &quot;escape hatch&quot; of sorts if you need precise control over the contents of the supplicant configuration. The contents of the wpa_supplicant_conf will be coppied without validation to the wpa_supplicant.conf file that VintageNet manages. Example: %{ type : VintageNetWiFi , vintage_net_wifi : %{ wpa_supplicant_conf : &quot;&quot;&quot; network={ ssid=&quot;home&quot; key_mgmt=WPA-PSK psk=&quot;very secret passphrase&quot; } &quot;&quot;&quot; } , ipv4 : %{ method : :dhcp } } Bridged Mesh WiFi In addition to infrastructure and AP modes, some WiFi modules can form a mesh. VintageNet supports the configuration of 802.11s meshes. While this is the standardize way of forming WiFi meshes, it is not the same as that implemented by many access points that advertise WiFi meshing. It also uses the 802.11s routing protocol HWMP. (This is not B.A.T.M.A.N.). This section describes two configuration: the first is for the mesh gate and the second is for the mesh devices. The mesh gate bridges the mesh network to the network that connects to the Internet. Mesh nodes behave similar to normal clients: after connecting to the network, they request an IP address using DHCP. The DHCP request gets routed through the mesh gate and to the DHCP server on the non-mesh LAN. It's possible to have multiple mesh gates. Routing through the mesh and the mesh gate is transparent. The following configuration is for a mesh gate with one WiFi interface used for the mesh network and a wired network interface, eth0 , that connects it to the LAN: mesh0_config = %{ type : VintageNetWiFi , vintage_net_wifi : %{ user_mpm : 1 , # mesh creates a &quot;virtual&quot; interface based on # this interface name root_interface : &quot;wlan0&quot; , networks : [ %{ key_mgmt : :none , ssid : &quot;my-mesh&quot; , frequency : 2432 , mode : :mesh } ] } , # we don&#39;t need an ip address on the mesh interface ipv4 : %{ method : :disabled } , } # Bridge configured to bridge eth0 and mesh0 together br0_config = %{ type : VintageNetBridge , ipv4 : %{ method : :dhcp } , vintage_net_bridge : %{ interfaces : [ &quot;eth0&quot; , &quot;mesh0&quot; ] } } eth0_config = %{ type : VintageNetEthernet , # the bridge handles ip addressing ipv4 : %{ method : :disabled } , } VintageNet . configure ( &quot;mesh0&quot; , mesh0_config ) VintageNet . configure ( &quot;br0&quot; , br0_config ) VintageNet . configure ( &quot;eth0&quot; , eth0_config ) This configuration is for devices on the mesh: mesh0_config = %{ type : VintageNetWiFi , vintage_net_wifi : %{ user_mpm : 1 , # mesh creates a &quot;virtual&quot; interface based on # this interface name root_interface : &quot;wlan0&quot; , networks : [ %{ key_mgmt : :none , ssid : &quot;my-mesh&quot; , frequency : 2432 , mode : :mesh } ] } , # the mesh is bridged on the other # device, so we can use dhcp now ipv4 : %{ method : :dhcp } , } VintageNet . configure ( &quot;mesh0&quot; , mesh0_config )","ref":"cookbook.html#wifi"},{"type":"extras","title":"VintageNet Cookbook - Network interaction","doc":"Share WAN with other networks For sharing your WAN connection (e.g. internet access) with other networks iptables must be installed. Currently this means building a custom nerves system . Once this is done the following commands need to be called on each boot: wan = &quot;eth0&quot; cmd &quot;sysctl -w net.ipv4.ip_forward=1&quot; cmd &quot;iptables -t nat -A POSTROUTING -o \#{ wan } -j MASQUERADE&quot; cmd &quot;iptables --append FORWARD --in-interface wlan0 -j ACCEPT&quot; # Only needed if the connection is blocked otherwise (like a default policy of DROP) cmd &quot;iptables -A INPUT -i \#{ wan } -m state --state RELATED,ESTABLISHED -j ACCEPT&quot;","ref":"cookbook.html#network-interaction"},{"type":"extras","title":"VintageNet Cookbook - Common tasks","doc":"Temporarily disable WiFi VintageNet persists configurations by default. Sometimes you just want to disable a network temporarily and then if the device reboots, it reboots to the old configuration. The :persist option let's you do this: VintageNet . deconfigure ( &quot;wlan0&quot; , persist : false ) To get the old configuration back, you have to call VintageNet.configure/3 with it again (or restart VintageNet or reboot). Perform some initialization to turn on a network interface VintageNet waits for network interfaces to appear before doing any work. If you need to perform some work to make the network interface show up, that has to be done elsewhere. If you let VintageNet know about this work and allow it to turn the network interface off too, it can &quot;cycle power&quot; to the interface to get it back to a clean state when needed. Here's how: defmodule MyPowerManager do @behaviour VintageNet.PowerManager @reset_n_gpio 4 @power_on_hold_time 5 * 60000 @min_powered_off_time 5000 defstruct reset_n : nil @impl VintageNet.PowerManager def init ( _args ) do { :ok , reset_n } = Circuits.GPIO . open ( @reset_n_gpio , :output ) { :ok , % __MODULE__ { reset_n : reset_n } } end @impl VintageNet.PowerManager def power_on ( state ) do # Do whatever is necessary to turn the network interface on Circuits.GPIO . write ( state . reset_n , 1 ) { :ok , state , @power_on_hold_time } end @impl VintageNet.PowerManager def start_powering_off ( state ) do # If there&#39;s a graceful power off, start it here and return # the max time it takes. { :ok , state , 0 } end @impl VintageNet.PowerManager def power_off ( state ) do # Disable the network interface Circuits.GPIO . write ( state . reset_n , 0 ) { :ok , state , @min_powered_off_time } end Then add the following to your config.exs : config :vintage_net , power_managers : [ { MyPowerManager , ifname : &quot;wlan0&quot; } ] VintageNet determines whether devices are ok by use of a watchdog. VintageNet and its technology implementations pet the watchdog by calling VintageNet.PowerManager.PMControl.pet_watchdog/1 . This may be insufficient for your application. Options include calling that function in your code regularly or modifying the :watchdog_timeout in the power manager spec in your config.exs . See VintageNet.PowerManager for details.","ref":"cookbook.html#common-tasks"},{"type":"extras","title":"Changelog","doc":"This project follows Semantic Versioning .","ref":"changelog.html"},{"type":"extras","title":"Changelog - [v0.13.3] - 2023-06-10","doc":"Changed Sort dhcpd options so their order doesn't change in configuration files made by OTP 26. This fixes regression test failures that expected the files to by the same. It shouldn't matter for real use, but it's nice that the files are deterministic just in case. Ignore unexpected messages to the InterfacesMonitor. This fixes an unnecessary crash/restart that was seen. Errors are still logged.","ref":"changelog.html#v0-13-3-2023-06-10"},{"type":"extras","title":"Changelog - [v0.13.2] - 2023-05-15","doc":"Changed Always set IPv4 broadcast address for static IPv4 configurations. This fixes an issue where the default for subnet broadcast address was not the expected host all-ones address per RFC 922. Prune out LAN addresses when trying to detect Internet connectivity. This fixes one way that the Internet checker could be tricked by a captive portal that resolves all DNS queries to its portal address. Fix confusion with :dhcpd :subnet option. This maps to the subnet mask field when responding to DHCP requests. The word &quot;subnet&quot; was interpreted as a subnet which was incorrect for this. :netmask is now an alias and examples are fixed.","ref":"changelog.html#v0-13-2-2023-05-15"},{"type":"extras","title":"Changelog - [v0.13.1] - 2023-03-15","doc":"This release fixes deprecation warnings when using Elixir 1.15.","ref":"changelog.html#v0-13-1-2023-03-15"},{"type":"extras","title":"Changelog - v0.13.0 - 2023-01-22","doc":"This release has a breaking change if you're using the UdhcpcHandler behaviour. This should be a rare use case. Use the &quot;dhcp_options&quot; property now. Changed Add &quot;dhcp_options&quot; to interface properties. This lets applications use information provided by DHCP servers in an easy way. It removes the need to process events from udhcpc directly, and therefore, the UdhcpcHandler behaviour is now a private API and may be removed in the future. Fix some references to iodata that should have been chardata .","ref":"changelog.html#v0-13-0-2023-01-22"},{"type":"extras","title":"Changelog - v0.12.2 - 2022-08-04","doc":"Changed Add VintageNet.info_as_ansidata/1 . This lets you get the same results as VintageNet.info , but in a way that's easy to put on a web page or send to a server, etc. Support updating network configuration even when it can't be persisted. Previously if there was an error saving the configuration and persist: true (the default), the configuration wouldn't be applied. This turned out to be problematic when trying to get some devices fixed. Now the device won't have the right config on reboot, but it can be reached over the network to be fixed.","ref":"changelog.html#v0-12-2-2022-08-04"},{"type":"extras","title":"Changelog - v0.12.1 - 2022-06-01","doc":"Changed The list of name servers that VintageNet uses when configuring the name resolve is now available by running VintageNet.get([&quot;name_servers&quot;]) .","ref":"changelog.html#v0-12-1-2022-06-01"},{"type":"extras","title":"Changelog - v0.12.0 - 2022-04-27","doc":"This release has two potentially breaking changes: Elixir 1.11 is now the minimum supported Elixir version. VintageNet.PropertyTable has been extracted to its own library and is now just PropertyTable . Most users did not use VintageNet.PropertyTable directly, but if you did, you'll need to update the references. Changed Extract VintageNet.PropertyTable to its own library. Note that many improvements were made to PropertyTable including renaming functions for consistency and changing the events. Code was added to VintageNet to hide these changes for now. Longer term, we'll be making things more consistent, but the hope is that the PropertyTable changes are transparent to VintageNet users in this release. Support specifying absolute paths to network configuration commands. While this is not preferred, it's useful in some scenarios. Redact more kinds of secrets in VintageNet.info","ref":"changelog.html#v0-12-0-2022-04-27"},{"type":"extras","title":"Changelog - v0.11.5 - 2022-02-18","doc":"Changed Fix a no function clause exception in the InternetChecker that could happen if no IP addresses were assigned to an interface.","ref":"changelog.html#v0-11-5-2022-02-18"},{"type":"extras","title":"Changelog - v0.11.4 - 2021-12-20","doc":"Changed Internet connectivity checks can now take domain names. Previously only IP addresses were supported. This change lets you add your own servers to the list since those servers may be more reliable indicators of Internet access in highly firewalled locations. A section on this was added to the README.md with an example.","ref":"changelog.html#v0-11-4-2021-12-20"},{"type":"extras","title":"Changelog - v0.11.3 - 2021-11-18","doc":"Changed Don't downgrade the connection status on DHCP renewals. Previously, if there was a DHCP renewal, the connection status could go from &quot;Internet-connected&quot; &quot;LAN-connected&quot;. The logic was that IP address and router changes may make the Internet unreachible. The new logic is to assume that the device is still Internet-connected and let the connectivity checker downgrade the status should it be necessary. This not only removes a status hiccup, but also fixes a race between the connectivity checker upgrading the connection and the DHCP notification degrading it. Improve the VintageNet.info error when the :vintage_net application stops.","ref":"changelog.html#v0-11-3-2021-11-18"},{"type":"extras","title":"Changelog - v0.11.2 - 2021-10-25","doc":"Added Added VintageNet.RouteManager.refresh_route_metrics/0 to recompute the routing table metrics. This is useful if you're supplying your own :route_metric_fun and something has changed to make it return a different prioritization. Thanks to @LostKobrakai for this feature.","ref":"changelog.html#v0-11-2-2021-10-25"},{"type":"extras","title":"Changelog - v0.11.1 - 2021-10-01","doc":"Changed The DNS server ordering is more deterministic now. Global DNS servers are guaranteed to be listed first and in the order specified. VintageNet will also try to preserve the ordering of DNS servers learned through DHCP. This isn't always possible, though. This fixes a hard-to-find error where an a difference in DNS server orderings between to device locations led to different behavior. Use VintageNet.ConnectivityChecker.* in VintageNet. The connectivity checker module change was half made in v0.11.0 , but the old module name was kept in a couple places to avoid breaking unit tests in other VintageNet libraries. Now it's completely converted. This doesn't affect runtime. Code that references the previous names will still get deprecation warnings like in v0.11.0 .","ref":"changelog.html#v0-11-1-2021-10-01"},{"type":"extras","title":"Changelog - v0.11.0 - 2021-08-19","doc":"This release should be a safe update for most users. Many routing table and internet connectivity check modules were updated, but the changes were primarily in private APIs. Added Support for detecting Internet connectivity on an interface passively by watching tx and rx stats on TCP sockets. For example, if you have a long-lived TCP connection (like for MQTT), the keepalive messages will bump tx and rx counters that will let VintageNet skip testing the connection for connectivity. This reduces traffic on metered connections. Support for completely overriding route metric calculation. You can now specify a :route_metric_fun instead of using the DefaultMetric calculator for determining which network interface preferences. VintageNet property change events now come with timestamps. These are useful for computing state durations and other time-based stats for events. Removed Support for setting route prioritization order. This feature was more limiting that it originally looked. The new :route_metric_fun is more straightforward since it lets you explicitly specify orderings and lets decisions be made based on more input data. Changed VintageNet.Interface.InternetConnectivityChecker is now VintageNet.Connectivity.InternetChecker . Please update any references. Old references will continue to work, but give a deprecation message at runtime.","ref":"changelog.html#v0-11-0-2021-08-19"},{"type":"extras","title":"Changelog - v0.10.5 - 2021-07-12","doc":"This release only contains build system and hex package update. It doesn't change any code and is a safe update.","ref":"changelog.html#v0-10-5-2021-07-12"},{"type":"extras","title":"Changelog - v0.10.4 - 2021-07-06","doc":"Fixed DHCP renewals would bounce connection status from :internet to :lan and back even when the IP address, subnet, and default gateway didn't change. This could cause a network connectivity hiccup that would happen every 24 hours (a common DHCP lease time). A fix was added to assume internet connectivity was maintained if the DHCP renewal didn't change IP parameters.","ref":"changelog.html#v0-10-4-2021-07-06"},{"type":"extras","title":"Changelog - v0.10.3 - 2021-06-22","doc":"Fixed Fix regression with tracking udhcpd lease notifications. Leases notifications were being ignored, so if you were monitoring leases to see who was connected, then you wouldn't see any connections without this fix. Thanks to Jon Thacker for reporting this issue. Fix crashes when the application config is invalid. While the configurations were incorrect and needed to be fixed, it was harder to debug than it should have been. This release logs messages on invalid configs and carries on bringing up left that's valid. Thanks to Matt Ludwigs for this fix.","ref":"changelog.html#v0-10-3-2021-06-22"},{"type":"extras","title":"Changelog - v0.10.2 - 2021-05-20","doc":"This release officially removes support for Elixir 1.7 and Elixir 1.8. It turns out that those versions wouldn't have worked in v0.10.0 due to a dependency that was added. Added Add VintageNet.reset_to_defaults/1 so that it's easy to reset a network interface's configuration to what it would be if VintageNet.configure had never been called. The previous &quot;easy&quot; way of doing this was to erase the persisted configuration file and reboot. Clean up interface reachability handling (disconnected vs. lan-connected vs internet-connected). There was an issue where the status was out of sync due a bug in a technology implementation. This is harder to do now. IMPORTANT: if you have a custom technology implementation, calling VintageNet.RouteManager.set_connection_status is sufficient. You no longer need to update the status property for your interface. This is not a common need.","ref":"changelog.html#v0-10-2-2021-05-20"},{"type":"extras","title":"Changelog - v0.10.1 - 2021-05-06","doc":"Added There's now an :additional_name_servers global configuration key so that it's possible to force name servers to always be in the list to use. For example, if you don't trust that you'll always get good name servers from DHCP, you can add a few public name servers to this list. /etc/resolv.conf now has nice comments on where configuration items come from. Thanks to Connor Rigby for this idea and implementation.","ref":"changelog.html#v0-10-1-2021-05-06"},{"type":"extras","title":"Changelog - v0.10.0 - 2021-04-06","doc":"This release is mostly backwards compatible. If you have created your own VintageNet technology, you may need to update your unit tests. If you are an end user of VintageNet, your code should continue to work unmodified. Added The Internet connectivity check logic now supports a list of IP addresses instead of just one. The default has been updated to include major public DNS providers. The code checks them in succession until one responds. See :internet_host_list config key in the README.md if you need to change it. Only start udhcpc / udhcpd when the network interface is up. This removes pointless attempts to get an IP address and their associated logs. It reduces connection time for wired Ethernet but doesn't affect WiFI. Fixed Replace Crypto API calls that are no longer included with OTP 24. Redact SAE passwords","ref":"changelog.html#v0-10-0-2021-04-06"},{"type":"extras","title":"Changelog - v0.9.3 - 2021-02-03","doc":"Fixed Be more robust to PowerManager.init/1 failures. While this function shouldn't raise, the effect of it raising was particularly destructive to VintageNet and took down networking. Update gen_state_machine dependency to let the 3.0.0 release be used.","ref":"changelog.html#v0-9-3-2021-02-03"},{"type":"extras","title":"Changelog - v0.9.2 - 2020-10-10","doc":"Fixed Handle missing commands as errors rather than raising. This makes it a little easier test vintage_net and libraries that use it. Fixes @doc tag warnings during compile time","ref":"changelog.html#v0-9-2-2020-10-10"},{"type":"extras","title":"Changelog - v0.9.1 - 2020-07-29","doc":"Fixed This fixes an issue where system networking binaries were not being resolved according to vintage_net 's view of the PATH . vintage_net looks in the standard directories by default, but it's possible to restrict or add locations.","ref":"changelog.html#v0-9-1-2020-07-29"},{"type":"extras","title":"Changelog - v0.9.0 - 2021-07-24","doc":"This release contains improvements that will not affect you unless you are using a custom VintageNet.Technology implementation. Added Add power management support. This adds support for powering on and off network devices and also enables VintageNet to restart devices that are not working (if allowed). See VintageNet.PowerManager for details. Changed Paths to networking programs like wpa_supplicant are no longer passed as opts during configuration. I.e., :bin_wpa_supplicant , :bin_ip , etc. This was not a generally useful feature since it wasn't possible to include all possible programs. A future plan is to add support for verifying that networking programs exist before trying to configure an interface. Programs should be passed as strings now. Support for the :busybox hex package has been removed. This was useful when networking programs were unavailable on a system, but all official Nerves systems have included them for the past year and :busybox required maintenance to keep working and up-to-date.","ref":"changelog.html#v0-9-0-2021-07-24"},{"type":"extras","title":"Changelog - v0.8.0 - 2020-05-29","doc":"Added [Breaking change for technology implementors] Decouple the network interface name from the one a network technology uses. For example, cellular modems can now have vintage_net wait for wwan0 to appear before setting up a PPP interface (like ppp0 ). All network technology implementations need to be updated to provide RawConfigs that list the network interfaces they need to start. This is hard to miss since you'll get a compile error if it affects you. Deterministic interface naming support - If you have a device with multiple network interfaces of the same type (e.g., multiple WiFi adapters) it is possible for them to switch between being assigned wlan0 and wlan1 under some conditions. This feature allows you to map their hardware location to a name of your choosing. See the README.md for details. Add the &quot;hw_path&quot; property - For example, {[&quot;interface&quot;, &quot;eth0&quot;, &quot;hw_path&quot;], &quot;/devices/platform/ocp/4a100000.ethernet&quot;} Fixed Stop network interface management GenServers before running the &quot;down&quot; commands. This is most noticeable in reduced log noise on network hiccups and device removals.","ref":"changelog.html#v0-8-0-2020-05-29"},{"type":"extras","title":"Changelog - v0.7.9 - 2020-04-07","doc":"Fixed Fix IP address being reported for PPP connections. Previously, it was the remote end of the PPP connection rather than the local end. Fix missing IPv6 address reports. Depending on when IPv6 addresses were set on network interfaces, they might not have been reported. Note that IPv6 isn't officially supported by VintageNet yet.","ref":"changelog.html#v0-7-9-2020-04-07"},{"type":"extras","title":"Changelog - v0.7.8 - 2020-04-03","doc":"Added Store an interface's configuration in the [&quot;interface&quot;, ifname, &quot;config&quot;] property. This makes it possible to subscribe to configuration changes (like any other property). Print out IP addresses with VintageNet.info/0 Fixed Fixed VintageNet.get_configuration/1 to return the configuration that will be applied even if it's not the configuration that's currently applied. The previous semantics would break code that made decisions based on the current configurations.","ref":"changelog.html#v0-7-8-2020-04-03"},{"type":"extras","title":"Changelog - v0.7.7 - 2020-03-23","doc":"Added Added time-in-state to VintageNet.info . This lets you see if a connection has bounced at a glance without digging through the logs.","ref":"changelog.html#v0-7-7-2020-03-23"},{"type":"extras","title":"Changelog - v0.7.6 - 2020-03-18","doc":"Fixed Ensure that Technology.normalize/1 is always called. Previously, this wasn't guaranteed, and it could result in a surprise when an unnormalized configuration got saved. Remove duplicate resolv.conf entries on multi-homed devices Fix warnings found by Elixir 1.10","ref":"changelog.html#v0-7-6-2020-03-18"},{"type":"extras","title":"Changelog - v0.7.5 - 2020-02-10","doc":"Fixed Fix routing table error when configuring multiple interfaces of the same type. Fix VintageNet.info for when it's called before vintage_net is loaded.","ref":"changelog.html#v0-7-5-2020-02-10"},{"type":"extras","title":"Changelog - v0.7.4 - 2020-01-22","doc":"Fixed Fix VintageNet.info crash when displaying AP mode configurations Save configurations using the :sync flag to reduce the chance that they're lost on ungraceful power offs. I.e., people pulling the power cable after device configuration.","ref":"changelog.html#v0-7-4-2020-01-22"},{"type":"extras","title":"Changelog - v0.7.3 - 2020-01-21","doc":"Added Scrub VintageNet.info/0 output to avoid accidental disclosure of WiFi credentials Support options to deconfigure/2 to mirror those on configure/2 Prefix udhcpc logs with interface to more easily blame problematic networks Support IPv4 /32 subnets Various documentation fixes and improvements","ref":"changelog.html#v0-7-3-2020-01-21"},{"type":"extras","title":"Changelog - v0.7.2 - 2019-12-20","doc":"Bug fix Remove noisy log message introduced in v0.7.1","ref":"changelog.html#v0-7-2-2019-12-20"},{"type":"extras","title":"Changelog - v0.7.1 - 2019-12-20","doc":"This release fixes an issue where the Internet-connectivity checking code could crash. It was automatically restarted, but that had a side effect of delaying a report that the device was connected AND breaking mdns_lite . Both the crash and the restart issue were fixed. The mdns_lite side effect was due to its multicast group membership being lost so this would affect other multicast-using code. Fixed Fix :timeout_value crash in the InternetConnectivityChecker Force clear IPv4 addresses when the DHCP notifies a deconfig event. This occurs on a restart and is quickly followed by a renew. However, if applications don't see this, bounce and don't register their multicast listeners on affected IPv4 address again, they'll lose the subscription. Added Added check for nerves_network and nerves_init_gadget . If your project pulls these in, it will get a moderately friendly notice to remove them.","ref":"changelog.html#v0-7-1-2019-12-20"},{"type":"extras","title":"Changelog - v0.7.0 - 2019-12-09","doc":"This release moves network technology implementations (WiFi, wired Ethernet, etc.) into their own projects. This means that they can evolve at their own pace. It also means that we're finally ready to support the VintageNet.Technology behaviour as part of the public API so that VintageNet users can add support for network technologies that we haven't gotten to yet. IMPORTANT: This change is not backwards compatible. You will need to update existing projects to bring in a new dependency. The runtime is backwards compatible. I.e., If you have a networking configuration saved in VintageNet, it will be updated on load. It won't be re-saved, so if you need to revert an update, it will still work. The next save, though, will use the new naming. If you're using VintageNet.Technology.Gadget , do the following: Add {:vintage_net_direct, &quot;~&gt; 0.7.0&quot;} to your mix.exs dependencies. You'll notice that references to &quot;gadget&quot; have been replaced with the word &quot;direct&quot;. We think the new naming is more accurate. Replace all references to VintageNet.Technology.Gadget in your code to VintageNetDirect . Be aware of aliases and configuration. If you passed options when configuring the network, the :gadget key is now :vintage_net_direct . Most users don't pass options. If you're using VintageNet.Technology.Ethernet , do the following: Add {:vintage_net_ethernet, &quot;~&gt; 0.7.0&quot;} to your mix.exs dependencies. Replace all references to VintageNet.Technology.Ethernet in your code to VintageNetEthernet . Be aware of aliases and configuration. If you're using VintageNet.Technology.WiFi , do the following: Add {:vintage_net_wifi, &quot;~&gt; 0.7.0&quot;} to your mix.exs dependencies. Replace all references to VintageNet.Technology.WiFi in your code to VintageNetWiFi . Be aware of aliases and configuration. Also, the &quot;F&quot; is capital. The :wifi key in the network configuration is now :vintage_net_wifi .","ref":"changelog.html#v0-7-0-2019-12-09"},{"type":"extras","title":"Changelog - v0.6.6 - 2019-12-01","doc":"Fixed Fix warning from Dialyzer when making wild card subscriptions. Code was also added to more thoroughly validate properties paths to raise on subtle issues that won't do what the programmer intends. Added Added VintageNet.match/1 to support &quot;gets&quot; on properties using wildcards.","ref":"changelog.html#v0-6-6-2019-12-01"},{"type":"extras","title":"Changelog - v0.6.5 - 2019-11-22","doc":"Added Support wild card subscriptions to properties. This makes it possible to subscribe to things like [&quot;interface&quot;, :_, &quot;addresses&quot;] where the :_ indicates that any value in the second position should match. That particular subscription would send a message whenever an IP address anywhere gets added, changed, or removed.","ref":"changelog.html#v0-6-5-2019-11-22"},{"type":"extras","title":"Changelog - v0.6.4 - 2019-10-31","doc":"Added Added the [&quot;interface&quot;, ifname, &quot;eap_status&quot;] property for EAP events. EAP is currently only supported on WiFi, but is anticipated for wired Ethernet too.","ref":"changelog.html#v0-6-4-2019-10-31"},{"type":"extras","title":"Changelog - v0.6.3 - 2019-10-28","doc":"This release renames the WiFi mode names. The old names still work so it's a backwards compatible update. The new names are :ap and :infrastructure instead of :host and :client . These names match the mode names in the IEEE specifications and usage elsewhere. Added Support static IPv4 configurations for a default gateway and list of name resolvers. See :gateway and :name_servers parameters. Support ad-hoc WiFi networking (IBSS mode)","ref":"changelog.html#v0-6-3-2019-10-28"},{"type":"extras","title":"Changelog - v0.6.2 - 2019-10-11","doc":"Added Support running a simple DNS server on an interface. This was added for WiFi AP mode configuration and could be useful for other scenarios. Support DHCP server response options Support disabling configuration persistence on a per-call basis. This is for temporary configurations where a reboot should not preserve the setting. For example, VintageNet.configure(&quot;wlan0&quot;, config, persist: false)","ref":"changelog.html#v0-6-2-2019-10-11"},{"type":"extras","title":"Changelog - v0.6.1 - 2019-10-02","doc":"Added Add a current_ap property for WiFi interfaces so that programs can get information about the currently associated access point Support running a DHCP server on wired Ethernet interfaces Expose VintageNet.WiFi.WPA2.validate_passphrase/1 so that applications can reuse the WiFI passphrase validation logic. This logic follows IEEE Std 802.11i-2004 and validates things like proper length and character set","ref":"changelog.html#v0-6-1-2019-10-02"},{"type":"extras","title":"Changelog - v0.6.0 - 2019-09-25","doc":"IMPORTANT: This release contains a LOT of changes. VintageNet is still pre-1.0 and we're actively making API changes as we gain real world experience with it. Please upgrade carefully. Changed All IP addresses are represented as tuples. You can still specify IP addresses as strings, like &quot;192.168.1.1&quot;, but it will be converted to tuple form. When you get the configuration, you'll see IP addresses as tuples. This means that if you save your configuration and revert to a previous version of VintageNet, the settings won't work. WiFi network configuration is always under the :networks key. This was inconsistent. Configuration normalization will update old saved configurations. Support for the IPv4 broadcast IP address has been removed. Existing support was incomplete and slightly confusing, so we decided to remove it for now. All IP address subnets are represented by their prefix length. For example, 255.255.255.0 is recorded as a subnet with prefix length 24. Configuration normalization converts subnet masks to prefix length now. Added USB gadget support - See VintageNet.Technology.Gadget . It is highly likely that we'll refactor USB gadget support to its own project in the future. Add :verbose key to configs for enabling debug messages from third party applications. Currently :verbose controls debug output from wpa_supplicant . Allow users to pass additional options to MuonTrap so that it's possible to run network daemons in cgroups (among other things) Fixed Networking daemons should all be supervised now. For example, udhcpc previously was started by ifup and under many conditions, it was possible to get numerous instances started simultaneously. Plus failures weren't detected. No more killall calls to cleanup state. This had prevented network technologies from being used on multiple interfaces. No more ifupdown . This was very convenient for getting started, but has numerous flaws. Search the Internet for rants. This was replaced with direct calls to ip link and ip addr and adding network daemons to supervision trees. Known issues Static IP addressing is still not implemented. It's only implemented enough for WiFi AP mode and USB gadget mode to work. We hope to fix this soon. It's not possible to temporarily configure network settings. At the moment, if persistence is enabled (the default), configuration updates are always saved.","ref":"changelog.html#v0-6-0-2019-09-25"},{"type":"extras","title":"Changelog - v0.5.1 - 2019-09-03","doc":"Fixed Add missing PSK conversion when configuring multiple WiFi networks. This fixes a bug where backup networks wouldn't connect. Added Don't poll WiFi networks that are configured for AP mode for Internet. They will never have it. Reduce the number of calls to update routing tables. Previously they were unnecessarily updated on DHCP failures due to timeouts. This also removes quite a bit of noise from the log. Filter out interfaces with &quot;Null&quot; technologies on them from the configured list. They really aren't configured so it was confusing to see them.","ref":"changelog.html#v0-5-1-2019-09-03"},{"type":"extras","title":"Changelog - v0.5.0 - 2019-08-08","doc":"Backwards incompatible change: The WiFi access point property (e.g., [&quot;interfaces&quot;, &quot;wlan0&quot;, &quot;access_points&quot;]) is now a simple list of access point structs. It was formerly a map and code using this property will need to be updated.","ref":"changelog.html#v0-5-0-2019-08-08"},{"type":"extras","title":"Changelog - v0.4.1 - 2019-07-29","doc":"Added Support run-time configuration of regulatory domain Error message improvement if build system is missing pkg-config","ref":"changelog.html#v0-4-1-2019-07-29"},{"type":"extras","title":"Changelog - v0.4.0 - 2019-07-22","doc":"Build note: The fix to support AP scanning when in AP-mode (see below) required pulling in libnl-3. All official Nerves systems have it installed since it is required by the wpa_supplicant. If you're doing host builds on Linux, you'll need to run apt install libnl-genl-3-dev . Added Report IP addresses in the interface properties. It's now possible to listen for IP address changes on interfaces. IPv4 and IPv6 addresses are reported. Support scanning for WiFi networks when an WiFi module is in AP mode. This lets you make WiFi configuration wizards. See the vintage_net_wizard project. Add interface MAC addresses to the interface properties Fixed Some WiFi adapters didn't work in AP mode since their drivers didn't support the P2P interface. Raspberry Pis all support the P2P interface, but some USB WiFi dongles do not. The wpa_supplicant interface code was updated to use fallback to the non-P2P interface in AP mode if it wasn't available.","ref":"changelog.html#v0-4-0-2019-07-22"},{"type":"extras","title":"Changelog - v0.3.1 - 2019-06-28","doc":"Added Add null persistence implementation for devices migrating from Nerves Network that already have a persistence strategy in place","ref":"changelog.html#v0-3-1-2019-06-28"},{"type":"extras","title":"Changelog - v0.3.0 - 2019-06-27","doc":"Added Support the busybox hex.pm package to bring in networking support if not present in the Nerves system image. This enables use with the minimal official Nerves images. Add Unix domain socket interface to the wpa_supplicant . This enables much faster scanning of WiFi networks and other things like collecting attached clients when in AP-mode and pinging the supplicant to make sure it's running. Log output of commandline-run applications so that error messages don't get lost. Provide utilities for reporting WiFi signal strength as a percent to end users. Fixed Support scanning WiFi access points with Unicode names (emoji, etc. in their SSIDs) Allow internet connectivity pings to be missed 3 times in a row before deciding that the internet isn't reachable. This avoids transients due to the random dropped packet. Reduce externally visible transients due to internal GenServers crashing and restarting - also addressed the crashes Support configure while configuring - let's you cancel a configuration that takes a long time to apply and apply a new one","ref":"changelog.html#v0-3-0-2019-06-27"},{"type":"extras","title":"Changelog - v0.2.4 - 2019-06-03","doc":"Added Listen for interface additions and physical layer notifications so that routing and status updates can be made much more quickly Add lower_up to the interface properties","ref":"changelog.html#v0-2-4-2019-06-03"},{"type":"extras","title":"Changelog - v0.2.3 - 2019-05-29","doc":"Fixed This release fixes supervision issues so that internal VintageNet crashes can be recovered VintageNet.get_configuration/1 works now &quot;available_interfaces&quot; is updated again","ref":"changelog.html#v0-2-3-2019-05-29"},{"type":"extras","title":"Changelog - v0.2.2 - 2019-05-24","doc":"Fixed Fix local LAN routing","ref":"changelog.html#v0-2-2-2019-05-24"},{"type":"extras","title":"Changelog - v0.2.1 - 2019-05-16","doc":"Added Expose summary status of whether the whole device is disconnected, LAN-connected, or Internet-connected","ref":"changelog.html#v0-2-1-2019-05-16"},{"type":"extras","title":"Changelog - v0.2.0 - 2019-05-15","doc":"Added Support WiFi AP mode - see README.md for example Fixed Alway update local routes before default routes to avoid getting errors when Linux detects a table entry that cannot be routed","ref":"changelog.html#v0-2-0-2019-05-15"},{"type":"extras","title":"Changelog - v0.1.0","doc":"Initial release to hex.","ref":"changelog.html#v0-1-0"}]